package StatLib;


import java.util.List;
import java.util.Date;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;

import java.lang.*;
import java.lang.reflect.*;
import java.util.StringTokenizer;
import java.io.*;



class StatFunc
  implements SystemTypes
{

  public StatFunc()
  {

  }



  public String toString()
  { String _res_ = "(StatFunc) ";
    return _res_;
  }

    public static int fact(int x)
  {   int result = 0;
    if (x < 0) { return result; } 
   
  if (x <= 1) 
  {   result = 1;
 
  }  else   if (x > 1) 
  {   result = x * StatFunc.fact(x - 1);
 
  }    return result;
  }


    public static int comb(int n,int m)
  {   int result = 0;
    if (n < m || m < 0) { return result; } 
   
  result = ( StatFunc.fact(n) * StatFunc.fact(n - m) ) / StatFunc.fact(m);
    return result;
  }



}



public class Controller implements SystemTypes, ControllerInterface
{
  Vector statfuncs = new Vector();
  private static Controller uniqueInstance; 


  private Controller() { } 


  public static Controller inst() 
    { if (uniqueInstance == null) 
    { uniqueInstance = new Controller(); }
    return uniqueInstance; } 

    public static int fact(int x)
    { return StatFunc.fact(x); } 

    public static int comb(int n,int m)
    { return StatFunc.comb(n,m); } 

  public static void loadModel(String file)
  {
    try
    { BufferedReader br = null;
      File f = new File(file);
      try 
      { br = new BufferedReader(new FileReader(f)); }
      catch (Exception ex) 
      { System.err.println("No file: " + file); return; }
      Class cont = Class.forName("StatLib.Controller");
      java.util.Map objectmap = new java.util.HashMap();
      while (true)
      { String line1;
        try { line1 = br.readLine(); }
        catch (Exception e)
        { return; }
        if (line1 == null)
        { return; }
        line1 = line1.trim();

        if (line1.length() == 0) { continue; }
        String left;
        String op;
        String right;
        if (line1.charAt(line1.length() - 1) == '"')
        { int eqind = line1.indexOf("="); 
          if (eqind == -1) { continue; }
          else 
          { left = line1.substring(0,eqind-1).trim();
            op = "="; 
            right = line1.substring(eqind+1,line1.length()).trim();
          }
        }
        else
        { StringTokenizer st1 = new StringTokenizer(line1);
          Vector vals1 = new Vector();
          while (st1.hasMoreTokens())
          { String val1 = st1.nextToken();
            vals1.add(val1);
          }
          if (vals1.size() < 3)
          { continue; }
          left = (String) vals1.get(0);
          op = (String) vals1.get(1);
          right = (String) vals1.get(2);
        }
        if (":".equals(op))
        { int i2 = right.indexOf(".");
          if (i2 == -1)
          { Class cl;
            try { cl = Class.forName("StatLib." + right); }
            catch (Exception _x) { System.err.println("No entity: " + right); continue; }
            Object xinst = cl.newInstance();
            objectmap.put(left,xinst);
            Class[] cargs = new Class[] { cl };
            Method addC = cont.getMethod("add" + right,cargs);
            if (addC == null) { continue; }
            Object[] args = new Object[] { xinst };
            addC.invoke(Controller.inst(),args);
          }
          else
          { String obj = right.substring(0,i2);
            String role = right.substring(i2+1,right.length());
            Object objinst = objectmap.get(obj); 
            if (objinst == null) 
            { continue; }
            Object val = objectmap.get(left);
            if (val == null) 
            { continue; }
            Class objC = objinst.getClass();
            Class typeclass = val.getClass(); 
            Object[] args = new Object[] { val }; 
            Class[] settypes = new Class[] { typeclass };
            Method addrole = Controller.findMethod(objC,"add" + role);
            if (addrole != null) 
            { addrole.invoke(objinst, args); }
            else { System.err.println("Error: cannot add to " + role); }
          }
        }
        else if ("=".equals(op))
        { int i1 = left.indexOf(".");
          if (i1 == -1) 
          { continue; }
          String obj = left.substring(0,i1);
          String att = left.substring(i1+1,left.length());
          Object objinst = objectmap.get(obj); 
          if (objinst == null) 
          { continue; }
          Class objC = objinst.getClass();
          Class typeclass; 
          Object val; 
          if (right.charAt(0) == '"' &&
              right.charAt(right.length() - 1) == '"')
          { typeclass = String.class;
            val = right.substring(1,right.length() - 1);
          } 
          else if ("true".equals(right) || "false".equals(right))
          { typeclass = boolean.class;
            if ("true".equals(right))
            { val = new Boolean(true); }
            else
            { val = new Boolean(false); }
          }
          else 
          { val = objectmap.get(right);
            if (val != null)
            { typeclass = val.getClass(); }
            else 
            { int i;
              double d;
              try 
              { i = Integer.parseInt(right);
                typeclass = int.class;
                val = new Integer(i); 
              }
              catch (Exception ee)
              { try
                { d = Double.parseDouble(right);
                  typeclass = double.class;
                  val = new Double(d);
                }
                catch (Exception ff)
                { continue; }
              }
            }
          }
          Object[] args = new Object[] { val }; 
          Class[] settypes = new Class[] { typeclass };
          Method setatt = Controller.findMethod(objC,"set" + att);
          if (setatt != null) 
          { setatt.invoke(objinst, args); }
          else { System.err.println("No attribute: " + att); }
        }
      }
    } catch (Exception e) { }
  }

  public static Method findMethod(Class c, String name)
  { Method[] mets = c.getMethods(); 
    for (int i = 0; i < mets.length; i++)
    { Method m = mets[i];
      if (m.getName().equals(name))
      { return m; }
    } 
    return null;
  }


  public void checkCompleteness()
  {   }


  public void saveModel(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
  for (int _i = 0; _i < statfuncs.size(); _i++)
  { StatFunc statfuncx_ = (StatFunc) statfuncs.get(_i);
    out.println("statfuncx_" + _i + " : StatFunc");
  }

    out.close(); 
  }


  public void saveXSI(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
    out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    out.println("<My:model xmi:version=\"2.0\" xmlns:xmi=\"http://www.omg.org/XMI\">");
    for (int _i = 0; _i < statfuncs.size(); _i++)
    { StatFunc statfuncx_ = (StatFunc) statfuncs.get(_i);
       out.print("<statfuncs xsi:type=\"My:StatFunc\"");
    out.println(" />");
  }

    out.println("</My:model>");
    out.close(); 
  }



  public void addStatFunc(StatFunc oo) { statfuncs.add(oo); }



  public void createAllStatFunc(List statfuncx)
  { for (int i = 0; i < statfuncx.size(); i++)
    { StatFunc statfuncx_x = (StatFunc) statfuncx.get(i);
      if (statfuncx_x == null) { statfuncx_x = new StatFunc(); }
      statfuncx.set(i,statfuncx_x);
      addStatFunc(statfuncx_x);
    }
  }


  public StatFunc createStatFunc()
  { 
    StatFunc statfuncx = new StatFunc();
    addStatFunc(statfuncx);

    return statfuncx;
  }



  public  List AllStatFuncfact(List statfuncxs,int x)
  { 
    List result = new Vector();
    for (int i = 0; i < statfuncxs.size(); i++)
    { StatFunc statfuncx = (StatFunc) statfuncxs.get(i);
      result.add(new Integer(statfuncx.fact(x)));
    }
    return result; 
  }

  public  List AllStatFunccomb(List statfuncxs,int n,int m)
  { 
    List result = new Vector();
    for (int i = 0; i < statfuncxs.size(); i++)
    { StatFunc statfuncx = (StatFunc) statfuncxs.get(i);
      result.add(new Integer(statfuncx.comb(n, m)));
    }
    return result; 
  }



  public void killAllStatFunc(List statfuncxx)
  { for (int _i = 0; _i < statfuncxx.size(); _i++)
    { killStatFunc((StatFunc) statfuncxx.get(_i)); }
  }

  public void killStatFunc(StatFunc statfuncxx)
  { statfuncs.remove(statfuncxx);
  }




   
}



