import ocl
import math


def free(x):
  del x


def displayint(x):
  print(str(x))

def displaylong(x):
  print(str(x))

def displaydouble(x):
  print(str(x))

def displayboolean(x):
  print(str(x))


class C:
  c_instances = []
  c_index = dict({})

  def __init__(self):
    C.c_instances.append(self)

class A:
  a_instances = []
  a_index = dict({})

  def __init__(self):
    self.aId = ""
    self.x = 0
    self.br = set({})
    self.cId = ""
    self.a = 0.0
    A.a_instances.append(self)

  def test(self) :
    result = ""
    result = ""
    displayint(self.x)
    result = self.x
    return result



  def a2b1(self) :
    if self.x > 0 :
      b = createByPKB(self.aId)
      b.y = "" + str(self.x)




class B:
  b_instances = []
  b_index = dict({})

  def __init__(self):
    self.bId = ""
    self.y = ""
    self.cId = ""
    self.a = 0.0
    B.b_instances.append(self)

  def sop(self, f) :
    result = ""
    result = ""
    result = f + " test " + self.y
    return result




class E:
  e_instances = []
  e_index = dict({})

  def __init__(self):
    self.eId = ""
    self.ar = set({})
    E.e_instances.append(self)

  def a2b2(self) :
    f = createByPKF(self.eId)
    f.br = getBByPKs([ax.aId for ax in self.ar])




class F:
  f_instances = []
  f_index = dict({})

  def __init__(self):
    self.fId = ""
    self.br = set({})
    F.f_instances.append(self)


def createA():
  a = A()
  return a

def allInstances_A():
  return A.a_instances


def createB():
  b = B()
  return b

def allInstances_B():
  return B.b_instances


def createE():
  e = E()
  return e

def allInstances_E():
  return E.e_instances


def createF():
  f = F()
  return f

def allInstances_F():
  return F.f_instances


def getAByPK(_ex) :
  if (_ex in A.a_index) :
    return A.a_index[_ex]
  else :
    return None


def getAByPKs(_exs) :
  result = []
  for _ex in _exs :
    if (_ex in A.a_index) :
      result.append(A.a_index[_ex])
  return result


def createByPKA(_value):
  result = getAByPK(_value)
  if (result != None) : 
    return result
  else :
    result = A()
    result.aId = _value
    A.a_index[_value] = result
    return result

def getBByPK(_ex) :
  if (_ex in B.b_index) :
    return B.b_index[_ex]
  else :
    return None


def getBByPKs(_exs) :
  result = []
  for _ex in _exs :
    if (_ex in B.b_index) :
      result.append(B.b_index[_ex])
  return result


def createByPKB(_value):
  result = getBByPK(_value)
  if (result != None) : 
    return result
  else :
    result = B()
    result.bId = _value
    B.b_index[_value] = result
    return result

def getCByPK(_ex) :
  if (_ex in C.c_index) :
    return C.c_index[_ex]
  else :
    return None


def getCByPKs(_exs) :
  result = []
  for _ex in _exs :
    if (_ex in C.c_index) :
      result.append(C.c_index[_ex])
  return result


def createByPKC(_value):
  result = getCByPK(_value)
  if (result != None) : 
    return result
  else :
    result = C()
    result.cId = _value
    C.c_index[_value] = result
    return result

def getEByPK(_ex) :
  if (_ex in E.e_index) :
    return E.e_index[_ex]
  else :
    return None


def getEByPKs(_exs) :
  result = []
  for _ex in _exs :
    if (_ex in E.e_index) :
      result.append(E.e_index[_ex])
  return result


def createByPKE(_value):
  result = getEByPK(_value)
  if (result != None) : 
    return result
  else :
    result = E()
    result.eId = _value
    E.e_index[_value] = result
    return result

def getFByPK(_ex) :
  if (_ex in F.f_index) :
    return F.f_index[_ex]
  else :
    return None


def getFByPKs(_exs) :
  result = []
  for _ex in _exs :
    if (_ex in F.f_index) :
      result.append(F.f_index[_ex])
  return result


def createByPKF(_value):
  result = getFByPK(_value)
  if (result != None) : 
    return result
  else :
    result = F()
    result.fId = _value
    F.f_index[_value] = result
    return result

def addA_br(a_x,b_x) :
  if b_x in a_x.br :
    return
  pass
  pass
  a_x.br = ocl.includingSet(a_x.br, b_x)



def removeA_br(a_x,b_x) :
  pass
  a_x.br = ocl.excludingSet(a_x.br, b_x)



def addE_ar(e_x,a_x) :
  if a_x in e_x.ar :
    return
  pass
  pass
  e_x.ar = ocl.includingSet(e_x.ar, a_x)



def removeE_ar(e_x,a_x) :
  pass
  e_x.ar = ocl.excludingSet(e_x.ar, a_x)



def addF_br(f_x,b_x) :
  if b_x in f_x.br :
    return
  pass
  pass
  f_x.br = ocl.includingSet(f_x.br, b_x)



def removeF_br(f_x,b_x) :
  pass
  f_x.br = ocl.excludingSet(f_x.br, b_x)



def killA(a_x) :
  a_instances = ocl.excludingSet(a_instances, a_x)
  for e_xx in allInstances_E() :
    e_xx.ar = ocl.excludingSet(e_xx.ar, a_x)
  
  
  free(a_x)



def killB(b_x) :
  b_instances = ocl.excludingSet(b_instances, b_x)
  for a_xx in allInstances_A() :
    a_xx.br = ocl.excludingSet(a_xx.br, b_x)
  for f_xx in allInstances_F() :
    f_xx.br = ocl.excludingSet(f_xx.br, b_x)
  
  
  free(b_x)



def killC(c_x) :
  c_instances = ocl.excludingSet(c_instances, c_x)



def killAbstractC(c_x) :
  if c_x in allInstances_B() :
    killB(c_x)
  else :
    if c_x in allInstances_A() :
      killA(c_x)
    else :
      pass



def killE(e_x) :
  e_instances = ocl.excludingSet(e_instances, e_x)
  free(e_x)



def killF(f_x) :
  f_instances = ocl.excludingSet(f_instances, f_x)
  free(f_x)



def a2b() :
  for loopvar_0 in allInstances_A() :
    loopvar_0.a2b1()
  for loopvar_1 in allInstances_E() :
    loopvar_1.a2b2()





