import java.io.*; 
import java.util.List; 
import java.util.Vector; 

public class TestGenQVT 
{ public static final int dim = 100;
  // Number of entities = dim, attributes = dim*dim

  public static void main(String[] args)
  { File file = new File("./inqvt" + dim + ".txt");
    try
    { PrintWriter out = new PrintWriter(
                              new BufferedWriter(
                                   new FileWriter(file)));
      writeModel(out); 
      out.close();
    }
    catch (IOException ex)
    { System.out.println("Error generating test"); } 
  } 

  public static void writeModel(PrintWriter out)
  { out.println("t1 : Type");
    out.println("t1.name = \"String\""); 
    
    for (int i = 0; i < dim; i++)
    { String cname = "c" + i;
      out.println(cname  + " : UMLClass");
      out.println(cname + ".name = \"" + cname + "\"");
    } 

    for (int i = 0; i < dim; i++)
    { String cname = "c" + i;
     
      for (int j = 0; j < 100; j++)
      { String pkname = "att" + i + "n" + j;
        out.println(pkname  + " : Attribute");
        out.println(pkname + ".name = \"" + pkname + "\"");
        out.println(pkname + ".type = t1"); 
        out.println(pkname + " : " + cname + ".attribute");
     }

   }
  }
}