import java.io.*; 

public class GeranTest
{ public static final int dim = 100;
  // Number of elements = dim

  public static void main(String[] args)
  { File file = new File("./dll.txt");
    try
    { PrintWriter out = new PrintWriter(
                              new BufferedWriter(
                                   new FileWriter(file)));
      writeModel(out); 
      out.close();
    }
    catch (IOException ex)
    { System.out.println("Error generating test"); }
  } 

  public static void writeModel(PrintWriter out)
  { out.println("list1 : DoublyLinkedList"); 
    out.println("list1.name = \"list1\""); 

    for (int i = 0; i < dim; i++)
    { String cname = "e" + i;
      out.println(cname  + " : Element");
      out.println(cname + ".name = \"" + cname + "\"");
      out.println(cname + ".list = list1");  
    } 

    for (int i = 0; i < dim - 1; i++)
    { String cname = "e" + i;
      String cnext = "e" + (i+1); 
      out.println(cname + ".target = " + cnext);
      out.println(cnext + ".source = " + cname);
    } 
    out.println("e" + (dim-1) + ".target = e0"); 
    out.println("e0" + ".source = e" + (dim-1)); 
  } 

}