import java.util.List;
import java.util.Date;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;

import java.lang.*;
import java.lang.reflect.*;
import java.util.StringTokenizer;
import java.io.*;



class DoublyLinkedList
  implements SystemTypes
{
  private String name = ""; // internal

  public DoublyLinkedList()
  {
    this.name = "";

  }



  public String toString()
  { String _res_ = "(DoublyLinkedList) ";
    _res_ = _res_ + name;
    return _res_;
  }

  public static DoublyLinkedList parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    DoublyLinkedList doublylinkedlistx = new DoublyLinkedList();
    doublylinkedlistx.name = (String) _line1vals.get(0);
      Controller.inst().doublylinkedlistnameindex.put(doublylinkedlistx.getname(), doublylinkedlistx);
    return doublylinkedlistx;
  }


  public void writeCSV(PrintWriter _out)
  { DoublyLinkedList doublylinkedlistx = this;
    _out.print("" + doublylinkedlistx.name);
    _out.println();
  }


  public void setname(String name_x) { name = name_x;  }


    public static void setAllname(List doublylinkedlists,String val)
  { for (int i = 0; i < doublylinkedlists.size(); i++)
    { DoublyLinkedList doublylinkedlistx = (DoublyLinkedList) doublylinkedlists.get(i);
      Controller.inst().setname(doublylinkedlistx,val); } }


    public String getname() { return name; }

    public static List getAllname(List doublylinkedlists)
  { List result = new Vector();
    for (int i = 0; i < doublylinkedlists.size(); i++)
    { DoublyLinkedList doublylinkedlistx = (DoublyLinkedList) doublylinkedlists.get(i);
      if (result.contains(doublylinkedlistx.getname())) { }
      else { result.add(doublylinkedlistx.getname()); } }
    return result; }

    public static List getAllOrderedname(List doublylinkedlists)
  { List result = new Vector();
    for (int i = 0; i < doublylinkedlists.size(); i++)
    { DoublyLinkedList doublylinkedlistx = (DoublyLinkedList) doublylinkedlists.get(i);
      result.add(doublylinkedlistx.getname()); } 
    return result; }

    public void copylist1()
  {   if (Controller.inst().getDoublyLinkedList1ByPK(this.getname()) != null)
    { DoublyLinkedList1 e = Controller.inst().getDoublyLinkedList1ByPK(this.getname());
   }
    else
    { DoublyLinkedList1 e = new DoublyLinkedList1();
    Controller.inst().addDoublyLinkedList1(e);
    Controller.inst().setname(e,this.getname()); }

  }


}


class Element
  implements SystemTypes
{
  private String name = ""; // internal
  private DoublyLinkedList list;
  private Element target;
  private Element source;

  public Element(DoublyLinkedList list,Element target,Element source)
  {
    this.name = "";
    this.list = list;
    this.target = target;
    this.source = source;

  }

  public Element() { }



  public String toString()
  { String _res_ = "(Element) ";
    _res_ = _res_ + name;
    return _res_;
  }

  public static Element parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    Element elementx = new Element();
    elementx.name = (String) _line1vals.get(0);
      Controller.inst().elementnameindex.put(elementx.getname(), elementx);
    return elementx;
  }


  public void writeCSV(PrintWriter _out)
  { Element elementx = this;
    _out.print("" + elementx.name);
    _out.println();
  }


  public void setname(String name_x) { name = name_x;  }


    public static void setAllname(List elements,String val)
  { for (int i = 0; i < elements.size(); i++)
    { Element elementx = (Element) elements.get(i);
      Controller.inst().setname(elementx,val); } }


  public void setlist(DoublyLinkedList list_xx) { list = list_xx;
  }

  public static void setAlllist(List elements, DoublyLinkedList _val)
  { for (int _i = 0; _i < elements.size(); _i++)
    { Element elementx = (Element) elements.get(_i);
      Controller.inst().setlist(elementx, _val); } }

  public void settarget(Element target_xx) { target = target_xx;
  }

  public static void setAlltarget(List elements, Element _val)
  { for (int _i = 0; _i < elements.size(); _i++)
    { Element elementx = (Element) elements.get(_i);
      Controller.inst().settarget(elementx, _val); } }

  public void setsource(Element source_xx) { source = source_xx;
  }

  public static void setAllsource(List elements, Element _val)
  { for (int _i = 0; _i < elements.size(); _i++)
    { Element elementx = (Element) elements.get(_i);
      Controller.inst().setsource(elementx, _val); } }

    public String getname() { return name; }

    public static List getAllname(List elements)
  { List result = new Vector();
    for (int i = 0; i < elements.size(); i++)
    { Element elementx = (Element) elements.get(i);
      if (result.contains(elementx.getname())) { }
      else { result.add(elementx.getname()); } }
    return result; }

    public static List getAllOrderedname(List elements)
  { List result = new Vector();
    for (int i = 0; i < elements.size(); i++)
    { Element elementx = (Element) elements.get(i);
      result.add(elementx.getname()); } 
    return result; }

  public DoublyLinkedList getlist() { return list; }

  public static List getAlllist(List elements)
  { List result = new Vector();
    for (int _i = 0; _i < elements.size(); _i++)
    { Element elementx = (Element) elements.get(_i);
      if (result.contains(elementx.getlist())) {}
      else { result.add(elementx.getlist()); }
 }
    return result; }

  public static List getAllOrderedlist(List elements)
  { List result = new Vector();
    for (int _i = 0; _i < elements.size(); _i++)
    { Element elementx = (Element) elements.get(_i);
      if (result.contains(elementx.getlist())) {}
      else { result.add(elementx.getlist()); }
 }
    return result; }

  public Element gettarget() { return target; }

  public static List getAlltarget(List elements)
  { List result = new Vector();
    for (int _i = 0; _i < elements.size(); _i++)
    { Element elementx = (Element) elements.get(_i);
      if (result.contains(elementx.gettarget())) {}
      else { result.add(elementx.gettarget()); }
 }
    return result; }

  public static List getAllOrderedtarget(List elements)
  { List result = new Vector();
    for (int _i = 0; _i < elements.size(); _i++)
    { Element elementx = (Element) elements.get(_i);
      if (result.contains(elementx.gettarget())) {}
      else { result.add(elementx.gettarget()); }
 }
    return result; }

  public Element getsource() { return source; }

  public static List getAllsource(List elements)
  { List result = new Vector();
    for (int _i = 0; _i < elements.size(); _i++)
    { Element elementx = (Element) elements.get(_i);
      if (result.contains(elementx.getsource())) {}
      else { result.add(elementx.getsource()); }
 }
    return result; }

  public static List getAllOrderedsource(List elements)
  { List result = new Vector();
    for (int _i = 0; _i < elements.size(); _i++)
    { Element elementx = (Element) elements.get(_i);
      if (result.contains(elementx.getsource())) {}
      else { result.add(elementx.getsource()); }
 }
    return result; }

    public void copylist2()
  {   if (Controller.inst().getElement1ByPK(this.getname()) != null)
    { Element1 e = Controller.inst().getElement1ByPK(this.getname());
     Controller.inst().setlist(e,Controller.inst().getDoublyLinkedList1ByPK(this.getlist().getname()));
  }
    else
    { Element1 e = new Element1();
    Controller.inst().addElement1(e);
    Controller.inst().setname(e,this.getname());
    Controller.inst().setlist(e,Controller.inst().getDoublyLinkedList1ByPK(this.getlist().getname())); }

  }

    public void copylist3(Element1 e)
  { Controller.inst().settarget(e,Controller.inst().getElement1ByPK(this.getsource().getname()));
  }

    public void copylist3outer()
  {  Element elementx = this;
    Element1 e = Controller.inst().getElement1ByPK(elementx.getname());
     this.copylist3(e);

  }



}


class DoublyLinkedList1
  implements SystemTypes
{
  private String name = ""; // internal

  public DoublyLinkedList1()
  {
    this.name = "";

  }



  public String toString()
  { String _res_ = "(DoublyLinkedList1) ";
    _res_ = _res_ + name;
    return _res_;
  }

  public static DoublyLinkedList1 parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    DoublyLinkedList1 doublylinkedlist1x = new DoublyLinkedList1();
    doublylinkedlist1x.name = (String) _line1vals.get(0);
      Controller.inst().doublylinkedlist1nameindex.put(doublylinkedlist1x.getname(), doublylinkedlist1x);
    return doublylinkedlist1x;
  }


  public void writeCSV(PrintWriter _out)
  { DoublyLinkedList1 doublylinkedlist1x = this;
    _out.print("" + doublylinkedlist1x.name);
    _out.println();
  }


  public void setname(String name_x) { name = name_x;  }


    public static void setAllname(List doublylinkedlist1s,String val)
  { for (int i = 0; i < doublylinkedlist1s.size(); i++)
    { DoublyLinkedList1 doublylinkedlist1x = (DoublyLinkedList1) doublylinkedlist1s.get(i);
      Controller.inst().setname(doublylinkedlist1x,val); } }


    public String getname() { return name; }

    public static List getAllname(List doublylinkedlist1s)
  { List result = new Vector();
    for (int i = 0; i < doublylinkedlist1s.size(); i++)
    { DoublyLinkedList1 doublylinkedlist1x = (DoublyLinkedList1) doublylinkedlist1s.get(i);
      if (result.contains(doublylinkedlist1x.getname())) { }
      else { result.add(doublylinkedlist1x.getname()); } }
    return result; }

    public static List getAllOrderedname(List doublylinkedlist1s)
  { List result = new Vector();
    for (int i = 0; i < doublylinkedlist1s.size(); i++)
    { DoublyLinkedList1 doublylinkedlist1x = (DoublyLinkedList1) doublylinkedlist1s.get(i);
      result.add(doublylinkedlist1x.getname()); } 
    return result; }


}


class Element1
  implements SystemTypes
{
  private String name = ""; // internal
  private DoublyLinkedList1 list;
  private Element1 target;
  private Element1 source;

  public Element1(DoublyLinkedList1 list,Element1 target,Element1 source)
  {
    this.name = "";
    this.list = list;
    this.target = target;
    this.source = source;

  }

  public Element1() { }



  public String toString()
  { String _res_ = "(Element1) ";
    _res_ = _res_ + name;
    return _res_;
  }

  public static Element1 parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    Element1 element1x = new Element1();
    element1x.name = (String) _line1vals.get(0);
      Controller.inst().element1nameindex.put(element1x.getname(), element1x);
    return element1x;
  }


  public void writeCSV(PrintWriter _out)
  { Element1 element1x = this;
    _out.print("" + element1x.name);
    _out.println();
  }


  public void setname(String name_x) { name = name_x;  }


    public static void setAllname(List element1s,String val)
  { for (int i = 0; i < element1s.size(); i++)
    { Element1 element1x = (Element1) element1s.get(i);
      Controller.inst().setname(element1x,val); } }


  public void setlist(DoublyLinkedList1 list_xx) { list = list_xx;
  }

  public static void setAlllist(List element1s, DoublyLinkedList1 _val)
  { for (int _i = 0; _i < element1s.size(); _i++)
    { Element1 element1x = (Element1) element1s.get(_i);
      Controller.inst().setlist(element1x, _val); } }

  public void settarget(Element1 target_xx) { target = target_xx;
  }

  public static void setAlltarget(List element1s, Element1 _val)
  { for (int _i = 0; _i < element1s.size(); _i++)
    { Element1 element1x = (Element1) element1s.get(_i);
      Controller.inst().settarget(element1x, _val); } }

  public void setsource(Element1 source_xx) { source = source_xx;
  }

  public static void setAllsource(List element1s, Element1 _val)
  { for (int _i = 0; _i < element1s.size(); _i++)
    { Element1 element1x = (Element1) element1s.get(_i);
      Controller.inst().setsource(element1x, _val); } }

    public String getname() { return name; }

    public static List getAllname(List element1s)
  { List result = new Vector();
    for (int i = 0; i < element1s.size(); i++)
    { Element1 element1x = (Element1) element1s.get(i);
      if (result.contains(element1x.getname())) { }
      else { result.add(element1x.getname()); } }
    return result; }

    public static List getAllOrderedname(List element1s)
  { List result = new Vector();
    for (int i = 0; i < element1s.size(); i++)
    { Element1 element1x = (Element1) element1s.get(i);
      result.add(element1x.getname()); } 
    return result; }

  public DoublyLinkedList1 getlist() { return list; }

  public static List getAlllist(List element1s)
  { List result = new Vector();
    for (int _i = 0; _i < element1s.size(); _i++)
    { Element1 element1x = (Element1) element1s.get(_i);
      if (result.contains(element1x.getlist())) {}
      else { result.add(element1x.getlist()); }
 }
    return result; }

  public static List getAllOrderedlist(List element1s)
  { List result = new Vector();
    for (int _i = 0; _i < element1s.size(); _i++)
    { Element1 element1x = (Element1) element1s.get(_i);
      if (result.contains(element1x.getlist())) {}
      else { result.add(element1x.getlist()); }
 }
    return result; }

  public Element1 gettarget() { return target; }

  public static List getAlltarget(List element1s)
  { List result = new Vector();
    for (int _i = 0; _i < element1s.size(); _i++)
    { Element1 element1x = (Element1) element1s.get(_i);
      if (result.contains(element1x.gettarget())) {}
      else { result.add(element1x.gettarget()); }
 }
    return result; }

  public static List getAllOrderedtarget(List element1s)
  { List result = new Vector();
    for (int _i = 0; _i < element1s.size(); _i++)
    { Element1 element1x = (Element1) element1s.get(_i);
      if (result.contains(element1x.gettarget())) {}
      else { result.add(element1x.gettarget()); }
 }
    return result; }

  public Element1 getsource() { return source; }

  public static List getAllsource(List element1s)
  { List result = new Vector();
    for (int _i = 0; _i < element1s.size(); _i++)
    { Element1 element1x = (Element1) element1s.get(_i);
      if (result.contains(element1x.getsource())) {}
      else { result.add(element1x.getsource()); }
 }
    return result; }

  public static List getAllOrderedsource(List element1s)
  { List result = new Vector();
    for (int _i = 0; _i < element1s.size(); _i++)
    { Element1 element1x = (Element1) element1s.get(_i);
      if (result.contains(element1x.getsource())) {}
      else { result.add(element1x.getsource()); }
 }
    return result; }


}


class CopyList
  implements SystemTypes
{

  public CopyList()
  {

  }



  public String toString()
  { String _res_ = "(CopyList) ";
    return _res_;
  }

  public static CopyList parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    CopyList copylistx = new CopyList();
    return copylistx;
  }


  public void writeCSV(PrintWriter _out)
  { CopyList copylistx = this;
    _out.println();
  }


  


}



public class Controller implements SystemTypes, ControllerInterface
{
  Vector doublylinkedlists = new Vector();
  Map doublylinkedlistnameindex = new HashMap(); // String --> DoublyLinkedList

  Vector elements = new Vector();
  Map elementnameindex = new HashMap(); // String --> Element

  Vector doublylinkedlist1s = new Vector();
  Map doublylinkedlist1nameindex = new HashMap(); // String --> DoublyLinkedList1

  Vector element1s = new Vector();
  Map element1nameindex = new HashMap(); // String --> Element1

  Vector copylists = new Vector();
  private static Controller uniqueInstance; 


  private Controller() { } 


  public static Controller inst() 
    { if (uniqueInstance == null) 
    { uniqueInstance = new Controller(); }
    return uniqueInstance; } 


  public static void loadModel(String file)
  {
    try
    { BufferedReader br = null;
      File f = new File(file);
      try 
      { br = new BufferedReader(new FileReader(f)); }
      catch (Exception ex) 
      { System.err.println("No file: " + file); return; }
      Class cont = Class.forName("Controller");
      java.util.Map objectmap = new java.util.HashMap();
      while (true)
      { String line1;
        try { line1 = br.readLine(); }
        catch (Exception e)
        { return; }
        if (line1 == null)
        { return; }
        line1 = line1.trim();

        if (line1.length() == 0) { continue; }
        if (line1.startsWith("//")) { continue; }
        String left;
        String op;
        String right;
        if (line1.charAt(line1.length() - 1) == '"')
        { int eqind = line1.indexOf("="); 
          if (eqind == -1) { continue; }
          else 
          { left = line1.substring(0,eqind-1).trim();
            op = "="; 
            right = line1.substring(eqind+1,line1.length()).trim();
          }
        }
        else
        { StringTokenizer st1 = new StringTokenizer(line1);
          Vector vals1 = new Vector();
          while (st1.hasMoreTokens())
          { String val1 = st1.nextToken();
            vals1.add(val1);
          }
          if (vals1.size() < 3)
          { continue; }
          left = (String) vals1.get(0);
          op = (String) vals1.get(1);
          right = (String) vals1.get(2);
        }
        if (":".equals(op))
        { int i2 = right.indexOf(".");
          if (i2 == -1)
          { Class cl;
            try { cl = Class.forName("" + right); }
            catch (Exception _x) { System.err.println("No entity: " + right); continue; }
            Object xinst = cl.newInstance();
            objectmap.put(left,xinst);
            Class[] cargs = new Class[] { cl };
            Method addC = null;
            try { addC = cont.getMethod("add" + right,cargs); }
            catch (Exception _xx) { System.err.println("No entity: " + right); continue; }
            if (addC == null) { continue; }
            Object[] args = new Object[] { xinst };
            addC.invoke(Controller.inst(),args);
          }
          else
          { String obj = right.substring(0,i2);
            String role = right.substring(i2+1,right.length());
            Object objinst = objectmap.get(obj); 
            if (objinst == null) 
            { continue; }
            Object val = objectmap.get(left);
            if (val == null) 
            { continue; }
            Class objC = objinst.getClass();
            Class typeclass = val.getClass(); 
            Object[] args = new Object[] { val }; 
            Class[] settypes = new Class[] { typeclass };
            Method addrole = Controller.findMethod(objC,"add" + role);
            if (addrole != null) 
            { addrole.invoke(objinst, args); }
            else { System.err.println("Error: cannot add to " + role); }
          }
        }
        else if ("=".equals(op))
        { int i1 = left.indexOf(".");
          if (i1 == -1) 
          { continue; }
          String obj = left.substring(0,i1);
          String att = left.substring(i1+1,left.length());
          Object objinst = objectmap.get(obj); 
          if (objinst == null) 
          { System.err.println("No object: " + obj); continue; }
          Class objC = objinst.getClass();
          Class typeclass; 
          Object val; 
          if (right.charAt(0) == '"' &&
              right.charAt(right.length() - 1) == '"')
          { typeclass = String.class;
            val = right.substring(1,right.length() - 1);
          } 
          else if ("true".equals(right) || "false".equals(right))
          { typeclass = boolean.class;
            if ("true".equals(right))
            { val = new Boolean(true); }
            else
            { val = new Boolean(false); }
          }
          else 
          { val = objectmap.get(right);
            if (val != null)
            { typeclass = val.getClass(); }
            else 
            { int i;
              long l; 
              double d;
              try 
              { i = Integer.parseInt(right);
                typeclass = int.class;
                val = new Integer(i); 
              }
              catch (Exception ee)
              { try 
                { l = Long.parseLong(right);
                  typeclass = long.class;
                  val = new Long(l); 
                }
                catch (Exception eee)
                { try
                  { d = Double.parseDouble(right);
                    typeclass = double.class;
                    val = new Double(d);
                  }
                  catch (Exception ff)
                  { continue; }
                }
              }
            }
          }
          Object[] args = new Object[] { val }; 
          Class[] settypes = new Class[] { typeclass };
          Method setatt = Controller.findMethod(objC,"set" + att);
          if (setatt != null) 
          { setatt.invoke(objinst, args); }
          else { System.err.println("No attribute: " + objC.getName() + "::" + att); }
        }
      }
    } catch (Exception e) { }
  }

  public static Method findMethod(Class c, String name)
  { Method[] mets = c.getMethods(); 
    for (int i = 0; i < mets.length; i++)
    { Method m = mets[i];
      if (m.getName().equals(name))
      { return m; }
    } 
    return null;
  }


  public static void loadCSVModel()
  { boolean __eof = false;
    String __s = "";
    Controller __cont = Controller.inst();
    BufferedReader __br = null;
    try
    { File _doublylinkedlist = new File("DoublyLinkedList.csv");
      __br = new BufferedReader(new FileReader(_doublylinkedlist));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { DoublyLinkedList doublylinkedlistx = DoublyLinkedList.parseCSV(__s.trim());
          if (doublylinkedlistx != null)
          { __cont.addDoublyLinkedList(doublylinkedlistx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _element = new File("Element.csv");
      __br = new BufferedReader(new FileReader(_element));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { Element elementx = Element.parseCSV(__s.trim());
          if (elementx != null)
          { __cont.addElement(elementx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _doublylinkedlist1 = new File("DoublyLinkedList1.csv");
      __br = new BufferedReader(new FileReader(_doublylinkedlist1));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { DoublyLinkedList1 doublylinkedlist1x = DoublyLinkedList1.parseCSV(__s.trim());
          if (doublylinkedlist1x != null)
          { __cont.addDoublyLinkedList1(doublylinkedlist1x); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _element1 = new File("Element1.csv");
      __br = new BufferedReader(new FileReader(_element1));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { Element1 element1x = Element1.parseCSV(__s.trim());
          if (element1x != null)
          { __cont.addElement1(element1x); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _copylist = new File("CopyList.csv");
      __br = new BufferedReader(new FileReader(_copylist));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { CopyList copylistx = CopyList.parseCSV(__s.trim());
          if (copylistx != null)
          { __cont.addCopyList(copylistx); }
        }
      }
    }
    catch(Exception __e) { }
  }


  public void checkCompleteness()
  {   for (int _i = 0; _i < doublylinkedlists.size(); _i++)
  { DoublyLinkedList doublylinkedlist_x = (DoublyLinkedList) doublylinkedlists.get(_i);
    DoublyLinkedList doublylinkedlist_obj = (DoublyLinkedList) doublylinkedlistnameindex.get(doublylinkedlist_x.getname());
    if (doublylinkedlist_obj == doublylinkedlist_x) { }
    else if (doublylinkedlist_obj == null)
    { doublylinkedlistnameindex.put(doublylinkedlist_x.getname(),doublylinkedlist_x); }
    else
    { System.out.println("Error: multiple objects with name = " + doublylinkedlist_x.getname()); }
  }
  for (int _i = 0; _i < elements.size(); _i++)
  { Element element_x = (Element) elements.get(_i);
    Element element_obj = (Element) elementnameindex.get(element_x.getname());
    if (element_obj == element_x) { }
    else if (element_obj == null)
    { elementnameindex.put(element_x.getname(),element_x); }
    else
    { System.out.println("Error: multiple objects with name = " + element_x.getname()); }
  }
  for (int _i = 0; _i < doublylinkedlist1s.size(); _i++)
  { DoublyLinkedList1 doublylinkedlist1_x = (DoublyLinkedList1) doublylinkedlist1s.get(_i);
    DoublyLinkedList1 doublylinkedlist1_obj = (DoublyLinkedList1) doublylinkedlist1nameindex.get(doublylinkedlist1_x.getname());
    if (doublylinkedlist1_obj == doublylinkedlist1_x) { }
    else if (doublylinkedlist1_obj == null)
    { doublylinkedlist1nameindex.put(doublylinkedlist1_x.getname(),doublylinkedlist1_x); }
    else
    { System.out.println("Error: multiple objects with name = " + doublylinkedlist1_x.getname()); }
  }
  for (int _i = 0; _i < element1s.size(); _i++)
  { Element1 element1_x = (Element1) element1s.get(_i);
    Element1 element1_obj = (Element1) element1nameindex.get(element1_x.getname());
    if (element1_obj == element1_x) { }
    else if (element1_obj == null)
    { element1nameindex.put(element1_x.getname(),element1_x); }
    else
    { System.out.println("Error: multiple objects with name = " + element1_x.getname()); }
  }
  for (int _i = 0; _i < elements.size(); _i++)
  { Element source_elementx1 = (Element) elements.get(_i);
    for (int _j = 0; _j < elements.size(); _j++)
    { Element target_elementx2 = (Element) elements.get(_j);
      if (source_elementx1.gettarget() == target_elementx2)
      { if (target_elementx2.getsource() == source_elementx1) { }
        else { target_elementx2.setsource(source_elementx1); }
      }
      else if (target_elementx2.getsource() == source_elementx1)
      { source_elementx1.settarget(target_elementx2); } 
    }
  }
  for (int _i = 0; _i < element1s.size(); _i++)
  { Element1 source_element1x1 = (Element1) element1s.get(_i);
    for (int _j = 0; _j < element1s.size(); _j++)
    { Element1 target_element1x2 = (Element1) element1s.get(_j);
      if (source_element1x1.gettarget() == target_element1x2)
      { if (target_element1x2.getsource() == source_element1x1) { }
        else { target_element1x2.setsource(source_element1x1); }
      }
      else if (target_element1x2.getsource() == source_element1x1)
      { source_element1x1.settarget(target_element1x2); } 
    }
  }
  }


  public void saveModel(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
  for (int _i = 0; _i < doublylinkedlists.size(); _i++)
  { DoublyLinkedList doublylinkedlistx_ = (DoublyLinkedList) doublylinkedlists.get(_i);
    out.println("doublylinkedlistx_" + _i + " : DoublyLinkedList");
    out.println("doublylinkedlistx_" + _i + ".name = \"" + doublylinkedlistx_.getname() + "\"");
  }

  for (int _i = 0; _i < elements.size(); _i++)
  { Element elementx_ = (Element) elements.get(_i);
    out.println("elementx_" + _i + " : Element");
    out.println("elementx_" + _i + ".name = \"" + elementx_.getname() + "\"");
  }

  for (int _i = 0; _i < doublylinkedlist1s.size(); _i++)
  { DoublyLinkedList1 doublylinkedlist1x_ = (DoublyLinkedList1) doublylinkedlist1s.get(_i);
    out.println("doublylinkedlist1x_" + _i + " : DoublyLinkedList1");
    out.println("doublylinkedlist1x_" + _i + ".name = \"" + doublylinkedlist1x_.getname() + "\"");
  }

  for (int _i = 0; _i < element1s.size(); _i++)
  { Element1 element1x_ = (Element1) element1s.get(_i);
    out.println("element1x_" + _i + " : Element1");
    out.println("element1x_" + _i + ".name = \"" + element1x_.getname() + "\"");
  }

  for (int _i = 0; _i < copylists.size(); _i++)
  { CopyList copylistx_ = (CopyList) copylists.get(_i);
    out.println("copylistx_" + _i + " : CopyList");
  }

  for (int _i = 0; _i < elements.size(); _i++)
  { Element elementx_ = (Element) elements.get(_i);
    out.println("elementx_" + _i + ".list = doublylinkedlistx_" + doublylinkedlists.indexOf(((Element) elements.get(_i)).getlist()));
    out.println("elementx_" + _i + ".target = elementx_" + elements.indexOf(((Element) elements.get(_i)).gettarget()));
    out.println("elementx_" + _i + ".source = elementx_" + elements.indexOf(((Element) elements.get(_i)).getsource()));
  }
  for (int _i = 0; _i < element1s.size(); _i++)
  { Element1 element1x_ = (Element1) element1s.get(_i);
    out.println("element1x_" + _i + ".list = doublylinkedlist1x_" + doublylinkedlist1s.indexOf(((Element1) element1s.get(_i)).getlist()));
    out.println("element1x_" + _i + ".target = element1x_" + element1s.indexOf(((Element1) element1s.get(_i)).gettarget()));
    out.println("element1x_" + _i + ".source = element1x_" + element1s.indexOf(((Element1) element1s.get(_i)).getsource()));
  }
    out.close(); 
  }


  public static void loadXSI()
  { boolean __eof = false;
    String __s = "";
    String xmlstring = "";
    BufferedReader __br = null;
    try
    { File _classmodel = new File("in.xmi");
      __br = new BufferedReader(new FileReader(_classmodel));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { xmlstring = xmlstring + __s; }
      } 
      __br.close();
    } 
    catch (Exception _x) { }
    Vector res = convertXsiToVector(xmlstring);
    File outfile = new File("_in.txt");
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
    for (int i = 0; i < res.size(); i++)
    { String r = (String) res.get(i); 
      out.println(r);
    } 
    out.close();
    loadModel("_in.txt");
  }

  public static Vector convertXsiToVector(String xmlstring)
  { Vector res = new Vector();
    XMLParser comp = new XMLParser();
    comp.nospacelexicalanalysisxml(xmlstring);
    XMLNode xml = comp.parseXML();
    if (xml == null) { return res; } 
    java.util.Map instancemap = new java.util.HashMap(); // String --> Vector
    java.util.Map entmap = new java.util.HashMap();       // String --> String
    Vector entcodes = new Vector(); 
    java.util.Map allattsmap = new java.util.HashMap(); // String --> Vector
    java.util.Map stringattsmap = new java.util.HashMap(); // String --> Vector
    java.util.Map onerolesmap = new java.util.HashMap(); // String --> Vector
    java.util.Map actualtype = new java.util.HashMap(); // XMLNode --> String
    Vector eallatts = new Vector();
    instancemap.put("doublylinkedlists", new Vector()); 
    instancemap.put("doublylinkedlist",new Vector()); 
    entcodes.add("doublylinkedlists");
    entcodes.add("doublylinkedlist");
    entmap.put("doublylinkedlists","DoublyLinkedList");
    entmap.put("doublylinkedlist","DoublyLinkedList");
    eallatts = new Vector();
    eallatts.add("name");
    allattsmap.put("DoublyLinkedList", eallatts);
    eallatts = new Vector();
    eallatts.add("name");
    stringattsmap.put("DoublyLinkedList", eallatts);
    eallatts = new Vector();
    onerolesmap.put("DoublyLinkedList", eallatts);
    instancemap.put("elements", new Vector()); 
    instancemap.put("element",new Vector()); 
    entcodes.add("elements");
    entcodes.add("element");
    entmap.put("elements","Element");
    entmap.put("element","Element");
    eallatts = new Vector();
    eallatts.add("name");
    allattsmap.put("Element", eallatts);
    eallatts = new Vector();
    eallatts.add("name");
    stringattsmap.put("Element", eallatts);
    eallatts = new Vector();
    eallatts.add("list");
    eallatts.add("target");
    eallatts.add("source");
    onerolesmap.put("Element", eallatts);
    instancemap.put("doublylinkedlist1s", new Vector()); 
    instancemap.put("doublylinkedlist1",new Vector()); 
    entcodes.add("doublylinkedlist1s");
    entcodes.add("doublylinkedlist1");
    entmap.put("doublylinkedlist1s","DoublyLinkedList1");
    entmap.put("doublylinkedlist1","DoublyLinkedList1");
    eallatts = new Vector();
    eallatts.add("name");
    allattsmap.put("DoublyLinkedList1", eallatts);
    eallatts = new Vector();
    eallatts.add("name");
    stringattsmap.put("DoublyLinkedList1", eallatts);
    eallatts = new Vector();
    onerolesmap.put("DoublyLinkedList1", eallatts);
    instancemap.put("element1s", new Vector()); 
    instancemap.put("element1",new Vector()); 
    entcodes.add("element1s");
    entcodes.add("element1");
    entmap.put("element1s","Element1");
    entmap.put("element1","Element1");
    eallatts = new Vector();
    eallatts.add("name");
    allattsmap.put("Element1", eallatts);
    eallatts = new Vector();
    eallatts.add("name");
    stringattsmap.put("Element1", eallatts);
    eallatts = new Vector();
    eallatts.add("list");
    eallatts.add("target");
    eallatts.add("source");
    onerolesmap.put("Element1", eallatts);
    instancemap.put("copylists", new Vector()); 
    instancemap.put("copylist",new Vector()); 
    entcodes.add("copylists");
    entcodes.add("copylist");
    entmap.put("copylists","CopyList");
    entmap.put("copylist","CopyList");
    eallatts = new Vector();
    allattsmap.put("CopyList", eallatts);
    eallatts = new Vector();
    stringattsmap.put("CopyList", eallatts);
    eallatts = new Vector();
    onerolesmap.put("CopyList", eallatts);
    eallatts = new Vector();
  Vector enodes = xml.getSubnodes();
  for (int i = 0; i < enodes.size(); i++)
  { XMLNode enode = (XMLNode) enodes.get(i);
    String cname = enode.getTag();
    Vector einstances = (Vector) instancemap.get(cname); 
    if (einstances == null) 
    { einstances = (Vector) instancemap.get(cname + "s"); }
    if (einstances != null) 
    { einstances.add(enode); }
  }
  for (int j = 0; j < entcodes.size(); j++)
  { String ename = (String) entcodes.get(j);
    Vector elems = (Vector) instancemap.get(ename);
    for (int k = 0; k < elems.size(); k++)
    { XMLNode enode = (XMLNode) elems.get(k);
      String tname = enode.getAttributeValue("xsi:type"); 
      if (tname == null) 
      { tname = (String) entmap.get(ename); } 
      else 
      { int colonind = tname.indexOf(":"); 
        if (colonind >= 0)
        { tname = tname.substring(colonind + 1,tname.length()); }
      }
      res.add(ename + k + " : " + tname);
      actualtype.put(enode,tname);
    }   
  }
  for (int j = 0; j < entcodes.size(); j++) 
  { String ename = (String) entcodes.get(j); 
    Vector elems = (Vector) instancemap.get(ename); 
    for (int k = 0; k < elems.size(); k++)
    { XMLNode enode = (XMLNode) elems.get(k);
      String tname = (String) actualtype.get(enode);
      Vector tallatts = (Vector)  allattsmap.get(tname);
      Vector tstringatts = (Vector)  stringattsmap.get(tname);
      Vector toneroles = (Vector)  onerolesmap.get(tname);
      Vector atts = enode.getAttributes();
      for (int p = 0; p < atts.size(); p++) 
      { XMLAttribute patt = (XMLAttribute) atts.get(p); 
        if (patt.getName().equals("xsi:type") || patt.getName().equals("xmi:id")) {} 
        else 
        { patt.getDataDeclarationFromXsi(res,tallatts,tstringatts,toneroles,ename + k, (String) entmap.get(ename)); } 
      }
    } 
  }  
  return res; } 

  public void saveXSI(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
    out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    out.println("<UMLRSDS:model xmi:version=\"2.0\" xmlns:xmi=\"http://www.omg.org/XMI\">");
    for (int _i = 0; _i < doublylinkedlists.size(); _i++)
    { DoublyLinkedList doublylinkedlistx_ = (DoublyLinkedList) doublylinkedlists.get(_i);
       out.print("<doublylinkedlists xsi:type=\"My:DoublyLinkedList\"");
    out.print(" name=\"" + doublylinkedlistx_.getname() + "\" ");
    out.println(" />");
  }

    for (int _i = 0; _i < elements.size(); _i++)
    { Element elementx_ = (Element) elements.get(_i);
       out.print("<elements xsi:type=\"My:Element\"");
    out.print(" name=\"" + elementx_.getname() + "\" ");
    out.print(" list=\"");
    out.print("//@doublylinkedlists." + doublylinkedlists.indexOf(((Element) elements.get(_i)).getlist()));
    out.print("\"");
    out.print(" target=\"");
    out.print("//@elements." + elements.indexOf(((Element) elements.get(_i)).gettarget()));
    out.print("\"");
    out.print(" source=\"");
    out.print("//@elements." + elements.indexOf(((Element) elements.get(_i)).getsource()));
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < doublylinkedlist1s.size(); _i++)
    { DoublyLinkedList1 doublylinkedlist1x_ = (DoublyLinkedList1) doublylinkedlist1s.get(_i);
       out.print("<doublylinkedlist1s xsi:type=\"My:DoublyLinkedList1\"");
    out.print(" name=\"" + doublylinkedlist1x_.getname() + "\" ");
    out.println(" />");
  }

    for (int _i = 0; _i < element1s.size(); _i++)
    { Element1 element1x_ = (Element1) element1s.get(_i);
       out.print("<element1s xsi:type=\"My:Element1\"");
    out.print(" name=\"" + element1x_.getname() + "\" ");
    out.print(" list=\"");
    out.print("//@doublylinkedlist1s." + doublylinkedlist1s.indexOf(((Element1) element1s.get(_i)).getlist()));
    out.print("\"");
    out.print(" target=\"");
    out.print("//@element1s." + element1s.indexOf(((Element1) element1s.get(_i)).gettarget()));
    out.print("\"");
    out.print(" source=\"");
    out.print("//@element1s." + element1s.indexOf(((Element1) element1s.get(_i)).getsource()));
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < copylists.size(); _i++)
    { CopyList copylistx_ = (CopyList) copylists.get(_i);
       out.print("<copylists xsi:type=\"My:CopyList\"");
    out.println(" />");
  }

    out.println("</UMLRSDS:model>");
    out.close(); 
  }


  public void saveCSVModel()
  { try {
      File _doublylinkedlist = new File("DoublyLinkedList.csv");
      PrintWriter _out_doublylinkedlist = new PrintWriter(new BufferedWriter(new FileWriter(_doublylinkedlist)));
      for (int __i = 0; __i < doublylinkedlists.size(); __i++)
      { DoublyLinkedList doublylinkedlistx = (DoublyLinkedList) doublylinkedlists.get(__i);
        doublylinkedlistx.writeCSV(_out_doublylinkedlist);
      }
      _out_doublylinkedlist.close();
      File _element = new File("Element.csv");
      PrintWriter _out_element = new PrintWriter(new BufferedWriter(new FileWriter(_element)));
      for (int __i = 0; __i < elements.size(); __i++)
      { Element elementx = (Element) elements.get(__i);
        elementx.writeCSV(_out_element);
      }
      _out_element.close();
      File _doublylinkedlist1 = new File("DoublyLinkedList1.csv");
      PrintWriter _out_doublylinkedlist1 = new PrintWriter(new BufferedWriter(new FileWriter(_doublylinkedlist1)));
      for (int __i = 0; __i < doublylinkedlist1s.size(); __i++)
      { DoublyLinkedList1 doublylinkedlist1x = (DoublyLinkedList1) doublylinkedlist1s.get(__i);
        doublylinkedlist1x.writeCSV(_out_doublylinkedlist1);
      }
      _out_doublylinkedlist1.close();
      File _element1 = new File("Element1.csv");
      PrintWriter _out_element1 = new PrintWriter(new BufferedWriter(new FileWriter(_element1)));
      for (int __i = 0; __i < element1s.size(); __i++)
      { Element1 element1x = (Element1) element1s.get(__i);
        element1x.writeCSV(_out_element1);
      }
      _out_element1.close();
      File _copylist = new File("CopyList.csv");
      PrintWriter _out_copylist = new PrintWriter(new BufferedWriter(new FileWriter(_copylist)));
      for (int __i = 0; __i < copylists.size(); __i++)
      { CopyList copylistx = (CopyList) copylists.get(__i);
        copylistx.writeCSV(_out_copylist);
      }
      _out_copylist.close();
    }
    catch(Exception __e) { }
  }



  public void addDoublyLinkedList(DoublyLinkedList oo) { doublylinkedlists.add(oo); }

  public DoublyLinkedList getDoublyLinkedListByPK(String namex)
  {  return (DoublyLinkedList) doublylinkedlistnameindex.get(namex); }

  public List getDoublyLinkedListByPK(List namex)
  { Vector res = new Vector(); 
    for (int _i = 0; _i < namex.size(); _i++)
    { DoublyLinkedList doublylinkedlistx = getDoublyLinkedListByPK((String) namex.get(_i));
      if (doublylinkedlistx != null) { res.add(doublylinkedlistx); }
    }
    return res; 
  }

  public void addElement(Element oo) { elements.add(oo); }

  public Element getElementByPK(String namex)
  {  return (Element) elementnameindex.get(namex); }

  public List getElementByPK(List namex)
  { Vector res = new Vector(); 
    for (int _i = 0; _i < namex.size(); _i++)
    { Element elementx = getElementByPK((String) namex.get(_i));
      if (elementx != null) { res.add(elementx); }
    }
    return res; 
  }

  public void addDoublyLinkedList1(DoublyLinkedList1 oo) { doublylinkedlist1s.add(oo); }

  public DoublyLinkedList1 getDoublyLinkedList1ByPK(String namex)
  {  return (DoublyLinkedList1) doublylinkedlist1nameindex.get(namex); }

  public List getDoublyLinkedList1ByPK(List namex)
  { Vector res = new Vector(); 
    for (int _i = 0; _i < namex.size(); _i++)
    { DoublyLinkedList1 doublylinkedlist1x = getDoublyLinkedList1ByPK((String) namex.get(_i));
      if (doublylinkedlist1x != null) { res.add(doublylinkedlist1x); }
    }
    return res; 
  }

  public void addElement1(Element1 oo) { element1s.add(oo); }

  public Element1 getElement1ByPK(String namex)
  {  return (Element1) element1nameindex.get(namex); }

  public List getElement1ByPK(List namex)
  { Vector res = new Vector(); 
    for (int _i = 0; _i < namex.size(); _i++)
    { Element1 element1x = getElement1ByPK((String) namex.get(_i));
      if (element1x != null) { res.add(element1x); }
    }
    return res; 
  }

  public void addCopyList(CopyList oo) { copylists.add(oo); }



  public DoublyLinkedList createDoublyLinkedList()
  { DoublyLinkedList doublylinkedlistx = new DoublyLinkedList();
    addDoublyLinkedList(doublylinkedlistx);
    return doublylinkedlistx;
  }

  public Element createElement()
  { Element elementx = new Element();
    addElement(elementx);
    return elementx;
  }

  public DoublyLinkedList1 createDoublyLinkedList1()
  { DoublyLinkedList1 doublylinkedlist1x = new DoublyLinkedList1();
    addDoublyLinkedList1(doublylinkedlist1x);
    return doublylinkedlist1x;
  }

  public Element1 createElement1()
  { Element1 element1x = new Element1();
    addElement1(element1x);
    return element1x;
  }

  public CopyList createCopyList()
  { CopyList copylistx = new CopyList();
    addCopyList(copylistx);
    return copylistx;
  }


public void setname(DoublyLinkedList doublylinkedlistx, String name_x) 
  { if (doublylinkedlistnameindex.get(name_x) != null) { return; }
  doublylinkedlistnameindex.remove(doublylinkedlistx.getname());
  doublylinkedlistx.setname(name_x);
  doublylinkedlistnameindex.put(name_x,doublylinkedlistx);
    }


public void setname(Element elementx, String name_x) 
  { if (elementnameindex.get(name_x) != null) { return; }
  elementnameindex.remove(elementx.getname());
  elementx.setname(name_x);
  elementnameindex.put(name_x,elementx);
    }


  public void setlist(Element elementx, DoublyLinkedList listxx) 
  {   if (elementx.getlist() == listxx) { return; }
    elementx.setlist(listxx);
      }


  public void settarget(Element elementx, Element targetxx) 
  {   if (elementx.gettarget() == targetxx) { return; }
    if (elementx.gettarget() != null)
    { elementx.gettarget().setsource(null); }
    if (targetxx.getsource() != null)
    { targetxx.getsource().settarget(null); }
    targetxx.setsource(elementx);
    elementx.settarget(targetxx);
      }


  public void setsource(Element elementx, Element sourcexx) 
  {   if (elementx.getsource() == sourcexx) { return; }
    if (elementx.getsource() != null)
    { elementx.getsource().settarget(null); }
    if (sourcexx.gettarget() != null)
    { sourcexx.gettarget().setsource(null); }
    sourcexx.settarget(elementx);
    elementx.setsource(sourcexx);
      }


public void setname(DoublyLinkedList1 doublylinkedlist1x, String name_x) 
  { if (doublylinkedlist1nameindex.get(name_x) != null) { return; }
  doublylinkedlist1nameindex.remove(doublylinkedlist1x.getname());
  doublylinkedlist1x.setname(name_x);
  doublylinkedlist1nameindex.put(name_x,doublylinkedlist1x);
    }


public void setname(Element1 element1x, String name_x) 
  { if (element1nameindex.get(name_x) != null) { return; }
  element1nameindex.remove(element1x.getname());
  element1x.setname(name_x);
  element1nameindex.put(name_x,element1x);
    }


  public void setlist(Element1 element1x, DoublyLinkedList1 listxx) 
  {   if (element1x.getlist() == listxx) { return; }
    element1x.setlist(listxx);
      }


  public void settarget(Element1 element1x, Element1 targetxx) 
  {   if (element1x.gettarget() == targetxx) { return; }
    if (element1x.gettarget() != null)
    { element1x.gettarget().setsource(null); }
    if (targetxx.getsource() != null)
    { targetxx.getsource().settarget(null); }
    targetxx.setsource(element1x);
    element1x.settarget(targetxx);
      }


  public void setsource(Element1 element1x, Element1 sourcexx) 
  {   if (element1x.getsource() == sourcexx) { return; }
    if (element1x.getsource() != null)
    { element1x.getsource().settarget(null); }
    if (sourcexx.gettarget() != null)
    { sourcexx.gettarget().setsource(null); }
    sourcexx.settarget(element1x);
    element1x.setsource(sourcexx);
      }



  public void copylist1(DoublyLinkedList doublylinkedlistx)
  {   doublylinkedlistx.copylist1();
   }

  public void copylist2(Element elementx)
  {   elementx.copylist2();
   }

  public void copylist3(Element elementx,Element1 e)
  {   elementx.copylist3(e);
   }

  public void copylist3outer(Element elementx)
  {   elementx.copylist3outer();
   }



  public void killAllDoublyLinkedList(List doublylinkedlistxx)
  { for (int _i = 0; _i < doublylinkedlistxx.size(); _i++)
    { killDoublyLinkedList((DoublyLinkedList) doublylinkedlistxx.get(_i)); }
  }

  public void killDoublyLinkedList(DoublyLinkedList doublylinkedlistxx)
  { if (doublylinkedlistxx == null) { return; }
   doublylinkedlists.remove(doublylinkedlistxx);
    Vector _1removedlistElement = new Vector();
    Vector _1qrangelistElement = new Vector();
    _1qrangelistElement.addAll(elements);
    for (int _i = 0; _i < _1qrangelistElement.size(); _i++)
    { Element elementx = (Element) _1qrangelistElement.get(_i);
      if (elementx != null && doublylinkedlistxx.equals(elementx.getlist()))
      { _1removedlistElement.add(elementx);
        elementx.setlist(null);
      }
    }
    doublylinkedlistnameindex.remove(doublylinkedlistxx.getname());
    for (int _i = 0; _i < _1removedlistElement.size(); _i++)
    { killElement((Element) _1removedlistElement.get(_i)); }
  }



  public void killAllElement(List elementxx)
  { for (int _i = 0; _i < elementxx.size(); _i++)
    { killElement((Element) elementxx.get(_i)); }
  }

  public void killElement(Element elementxx)
  { if (elementxx == null) { return; }
   elements.remove(elementxx);
    Vector _1removedtargetElement = new Vector();
    Vector _2removedsourceElement = new Vector();
    Vector _1qrangetargetElement = new Vector();
    _1qrangetargetElement.add(elementxx.getsource());
    for (int _i = 0; _i < _1qrangetargetElement.size(); _i++)
    { Element elementx = (Element) _1qrangetargetElement.get(_i);
      if (elementx != null && elementxx.equals(elementx.gettarget()))
      { _1removedtargetElement.add(elementx);
        elementx.settarget(null);
      }
    }
    Vector _2qrangesourceElement = new Vector();
    _2qrangesourceElement.add(elementxx.gettarget());
    for (int _i = 0; _i < _2qrangesourceElement.size(); _i++)
    { Element elementx = (Element) _2qrangesourceElement.get(_i);
      if (elementx != null && elementxx.equals(elementx.getsource()))
      { _2removedsourceElement.add(elementx);
        elementx.setsource(null);
      }
    }
    elementnameindex.remove(elementxx.getname());
    for (int _i = 0; _i < _1removedtargetElement.size(); _i++)
    { killElement((Element) _1removedtargetElement.get(_i)); }
    for (int _i = 0; _i < _2removedsourceElement.size(); _i++)
    { killElement((Element) _2removedsourceElement.get(_i)); }
  }



  public void killAllDoublyLinkedList1(List doublylinkedlist1xx)
  { for (int _i = 0; _i < doublylinkedlist1xx.size(); _i++)
    { killDoublyLinkedList1((DoublyLinkedList1) doublylinkedlist1xx.get(_i)); }
  }

  public void killDoublyLinkedList1(DoublyLinkedList1 doublylinkedlist1xx)
  { if (doublylinkedlist1xx == null) { return; }
   doublylinkedlist1s.remove(doublylinkedlist1xx);
    Vector _1removedlistElement1 = new Vector();
    Vector _1qrangelistElement1 = new Vector();
    _1qrangelistElement1.addAll(element1s);
    for (int _i = 0; _i < _1qrangelistElement1.size(); _i++)
    { Element1 element1x = (Element1) _1qrangelistElement1.get(_i);
      if (element1x != null && doublylinkedlist1xx.equals(element1x.getlist()))
      { _1removedlistElement1.add(element1x);
        element1x.setlist(null);
      }
    }
    doublylinkedlist1nameindex.remove(doublylinkedlist1xx.getname());
    for (int _i = 0; _i < _1removedlistElement1.size(); _i++)
    { killElement1((Element1) _1removedlistElement1.get(_i)); }
  }



  public void killAllElement1(List element1xx)
  { for (int _i = 0; _i < element1xx.size(); _i++)
    { killElement1((Element1) element1xx.get(_i)); }
  }

  public void killElement1(Element1 element1xx)
  { if (element1xx == null) { return; }
   element1s.remove(element1xx);
    Vector _1removedtargetElement1 = new Vector();
    Vector _2removedsourceElement1 = new Vector();
    Vector _1qrangetargetElement1 = new Vector();
    _1qrangetargetElement1.add(element1xx.getsource());
    for (int _i = 0; _i < _1qrangetargetElement1.size(); _i++)
    { Element1 element1x = (Element1) _1qrangetargetElement1.get(_i);
      if (element1x != null && element1xx.equals(element1x.gettarget()))
      { _1removedtargetElement1.add(element1x);
        element1x.settarget(null);
      }
    }
    Vector _2qrangesourceElement1 = new Vector();
    _2qrangesourceElement1.add(element1xx.gettarget());
    for (int _i = 0; _i < _2qrangesourceElement1.size(); _i++)
    { Element1 element1x = (Element1) _2qrangesourceElement1.get(_i);
      if (element1x != null && element1xx.equals(element1x.getsource()))
      { _2removedsourceElement1.add(element1x);
        element1x.setsource(null);
      }
    }
    element1nameindex.remove(element1xx.getname());
    for (int _i = 0; _i < _1removedtargetElement1.size(); _i++)
    { killElement1((Element1) _1removedtargetElement1.get(_i)); }
    for (int _i = 0; _i < _2removedsourceElement1.size(); _i++)
    { killElement1((Element1) _2removedsourceElement1.get(_i)); }
  }



  public void killAllCopyList(List copylistxx)
  { for (int _i = 0; _i < copylistxx.size(); _i++)
    { killCopyList((CopyList) copylistxx.get(_i)); }
  }

  public void killCopyList(CopyList copylistxx)
  { if (copylistxx == null) { return; }
   copylists.remove(copylistxx);
  }




  
  
  public void copyList() 
  { java.util.Date d1 = new java.util.Date(); 
    long t1 = d1.getTime(); 

    List _range4 = new Vector();
  _range4.addAll(Controller.inst().doublylinkedlists);
  for (int _i3 = 0; _i3 < _range4.size(); _i3++)
  { DoublyLinkedList loopvar_0 = (DoublyLinkedList) _range4.get(_i3);
       Controller.inst().copylist1(loopvar_0);
  }
    List _range6 = new Vector();
  _range6.addAll(Controller.inst().elements);
  for (int _i5 = 0; _i5 < _range6.size(); _i5++)
  { Element loopvar_1 = (Element) _range6.get(_i5);
       Controller.inst().copylist2(loopvar_1);
  }
    List _range8 = new Vector();
  _range8.addAll(Controller.inst().elements);
  for (int _i7 = 0; _i7 < _range8.size(); _i7++)
  { Element loopvar_2 = (Element) _range8.get(_i7);
       Controller.inst().copylist3outer(loopvar_2);
  }

  java.util.Date d2 = new java.util.Date(); 
    long t2 = d2.getTime(); 
    System.out.println("Time = " + (t2-t1)); 
  }


 
}



