import java.util.List;
import java.util.Date;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;

import java.lang.*;
import java.lang.reflect.*;
import java.util.StringTokenizer;
import java.io.*;



class Attribute
  implements SystemTypes
{
  private String name = ""; // internal
  private Type type;

  public Attribute(Type type)
  {
    this.name = "";
    this.type = type;

  }

  public Attribute() { }



  public String toString()
  { String _res_ = "(Attribute) ";
    _res_ = _res_ + name;
    return _res_;
  }

  public void setname(String name_x) { name = name_x;  }


  public static void setAllname(List attributes,String val)
{ for (int i = 0; i < attributes.size(); i++)
    { Attribute attributex = (Attribute) attributes.get(i);
      Controller.inst().setname(attributex,val); } }


  public void settype(Type typexx) { type = typexx;
  }

  public static void setAlltype(List attributes,Type _val)
  { for (int _i = 0; _i < attributes.size(); _i++)
    { Attribute attributex = (Attribute) attributes.get(_i);
      Controller.inst().settype(attributex, _val); } }

  public String getname() { return name; }

  public static List getAllname(List attributes)
  { List result = new Vector();
    for (int i = 0; i < attributes.size(); i++)
    { Attribute attributex = (Attribute) attributes.get(i);
      if (result.contains(attributex.getname())) { }
      else { result.add(attributex.getname()); } }
    return result; }

  public static List getAllOrderedname(List attributes)
  { List result = new Vector();
    for (int i = 0; i < attributes.size(); i++)
    { Attribute attributex = (Attribute) attributes.get(i);
      result.add(attributex.getname()); } 
    return result; }

  public Type gettype() { return type; }

  public static List getAlltype(List attributes)
  { List result = new Vector();
    for (int _i = 0; _i < attributes.size(); _i++)
    { Attribute attributex = (Attribute) attributes.get(_i);
      if (result.contains(attributex.gettype())) {}
      else { result.add(attributex.gettype()); }
 }
    return result; }

  public static List getAllOrderedtype(List attributes)
  { List result = new Vector();
    for (int _i = 0; _i < attributes.size(); _i++)
    { Attribute attributex = (Attribute) attributes.get(_i);
      if (result.contains(attributex.gettype())) {}
      else { result.add(attributex.gettype()); }
 }
    return result; }


}


class Column
  implements SystemTypes
{
  private String name = ""; // internal
  private String coltype = ""; // internal

  public Column()
  {
    this.name = "";
    this.coltype = "";

  }



  public String toString()
  { String _res_ = "(Column) ";
    _res_ = _res_ + name + ",";
    _res_ = _res_ + coltype;
    return _res_;
  }

  public void setname(String name_x) { name = name_x;  }


  public static void setAllname(List columns,String val)
{ for (int i = 0; i < columns.size(); i++)
    { Column columnx = (Column) columns.get(i);
      Controller.inst().setname(columnx,val); } }


  public void setcoltype(String coltype_x) { coltype = coltype_x;  }


  public static void setAllcoltype(List columns,String val)
{ for (int i = 0; i < columns.size(); i++)
    { Column columnx = (Column) columns.get(i);
      Controller.inst().setcoltype(columnx,val); } }


  public String getname() { return name; }

  public static List getAllname(List columns)
  { List result = new Vector();
    for (int i = 0; i < columns.size(); i++)
    { Column columnx = (Column) columns.get(i);
      if (result.contains(columnx.getname())) { }
      else { result.add(columnx.getname()); } }
    return result; }

  public static List getAllOrderedname(List columns)
  { List result = new Vector();
    for (int i = 0; i < columns.size(); i++)
    { Column columnx = (Column) columns.get(i);
      result.add(columnx.getname()); } 
    return result; }

  public String getcoltype() { return coltype; }

  public static List getAllcoltype(List columns)
  { List result = new Vector();
    for (int i = 0; i < columns.size(); i++)
    { Column columnx = (Column) columns.get(i);
      if (result.contains(columnx.getcoltype())) { }
      else { result.add(columnx.getcoltype()); } }
    return result; }

  public static List getAllOrderedcoltype(List columns)
  { List result = new Vector();
    for (int i = 0; i < columns.size(); i++)
    { Column columnx = (Column) columns.get(i);
      result.add(columnx.getcoltype()); } 
    return result; }


}


class UMLClass
  implements SystemTypes
{
  private String name = ""; // internal
  private List attribute = new Vector(); // of Attribute

  public UMLClass()
  {
    this.name = "";

  }



  public String toString()
  { String _res_ = "(UMLClass) ";
    _res_ = _res_ + name;
    return _res_;
  }

  public void setname(String name_x) { name = name_x;  }


  public static void setAllname(List umlclasss,String val)
{ for (int i = 0; i < umlclasss.size(); i++)
    { UMLClass umlclassx = (UMLClass) umlclasss.get(i);
      Controller.inst().setname(umlclassx,val); } }


  public void setattribute(List attributexx) { attribute = attributexx;
    }
 
  public void addattribute(Attribute attributexx) { attribute.add(attributexx);
    }
 
  public void removeattribute(Attribute attributexx) { Vector _removedattributeattributexx = new Vector();
  _removedattributeattributexx.add(attributexx);
  attribute.removeAll(_removedattributeattributexx);
    }

  public static void setAllattribute(List umlclasss,List _val)
  { for (int _i = 0; _i < umlclasss.size(); _i++)
    { UMLClass umlclassx = (UMLClass) umlclasss.get(_i);
      Controller.inst().setattribute(umlclassx, _val); } }

  public static void addAllattribute(List umlclasss,Attribute _val)
  { for (int _i = 0; _i < umlclasss.size(); _i++)
    { UMLClass umlclassx = (UMLClass) umlclasss.get(_i);
      Controller.inst().addattribute(umlclassx, _val); } }


  public static void removeAllattribute(List umlclasss,Attribute _val)
  { for (int _i = 0; _i < umlclasss.size(); _i++)
    { UMLClass umlclassx = (UMLClass) umlclasss.get(_i);
      Controller.inst().removeattribute(umlclassx, _val); } }


  public static void unionAllattribute(List umlclasss, List _val)
  { for (int _i = 0; _i < umlclasss.size(); _i++)
    { UMLClass umlclassx = (UMLClass) umlclasss.get(_i);
      Controller.inst().unionattribute(umlclassx, _val); } }


  public static void subtractAllattribute(List umlclasss, List _val)
  { for (int _i = 0; _i < umlclasss.size(); _i++)
    { UMLClass umlclassx = (UMLClass) umlclasss.get(_i);
      Controller.inst().subtractattribute(umlclassx, _val); } }


  public String getname() { return name; }

  public static List getAllname(List umlclasss)
  { List result = new Vector();
    for (int i = 0; i < umlclasss.size(); i++)
    { UMLClass umlclassx = (UMLClass) umlclasss.get(i);
      if (result.contains(umlclassx.getname())) { }
      else { result.add(umlclassx.getname()); } }
    return result; }

  public static List getAllOrderedname(List umlclasss)
  { List result = new Vector();
    for (int i = 0; i < umlclasss.size(); i++)
    { UMLClass umlclassx = (UMLClass) umlclasss.get(i);
      result.add(umlclassx.getname()); } 
    return result; }

  public List getattribute() { return (Vector) ((Vector) attribute).clone(); }

  public static List getAllattribute(List umlclasss)
  { List result = new Vector();
    for (int _i = 0; _i < umlclasss.size(); _i++)
    { UMLClass umlclassx = (UMLClass) umlclasss.get(_i);
      result = Set.union(result,umlclassx.getattribute()); }
    return result; }

  public static List getAllOrderedattribute(List umlclasss)
  { List result = new Vector();
    for (int _i = 0; _i < umlclasss.size(); _i++)
    { UMLClass umlclassx = (UMLClass) umlclasss.get(_i);
      result = Set.union(result,umlclassx.getattribute()); }
    return result; }


}


class Table
  implements SystemTypes
{
  private String name = ""; // internal
  private List column = new Vector(); // of Column

  public Table()
  {
    this.name = "";

  }



  public String toString()
  { String _res_ = "(Table) ";
    _res_ = _res_ + name;
    return _res_;
  }

  public void setname(String name_x) { name = name_x;  }


  public static void setAllname(List tables,String val)
{ for (int i = 0; i < tables.size(); i++)
    { Table tablex = (Table) tables.get(i);
      Controller.inst().setname(tablex,val); } }


  public void setcolumn(List columnxx) { column = columnxx;
    }
 
  public void addcolumn(Column columnxx) { column.add(columnxx);
    }
 
  public void removecolumn(Column columnxx) { Vector _removedcolumncolumnxx = new Vector();
  _removedcolumncolumnxx.add(columnxx);
  column.removeAll(_removedcolumncolumnxx);
    }

  public static void setAllcolumn(List tables,List _val)
  { for (int _i = 0; _i < tables.size(); _i++)
    { Table tablex = (Table) tables.get(_i);
      Controller.inst().setcolumn(tablex, _val); } }

  public static void addAllcolumn(List tables,Column _val)
  { for (int _i = 0; _i < tables.size(); _i++)
    { Table tablex = (Table) tables.get(_i);
      Controller.inst().addcolumn(tablex, _val); } }


  public static void removeAllcolumn(List tables,Column _val)
  { for (int _i = 0; _i < tables.size(); _i++)
    { Table tablex = (Table) tables.get(_i);
      Controller.inst().removecolumn(tablex, _val); } }


  public static void unionAllcolumn(List tables, List _val)
  { for (int _i = 0; _i < tables.size(); _i++)
    { Table tablex = (Table) tables.get(_i);
      Controller.inst().unioncolumn(tablex, _val); } }


  public static void subtractAllcolumn(List tables, List _val)
  { for (int _i = 0; _i < tables.size(); _i++)
    { Table tablex = (Table) tables.get(_i);
      Controller.inst().subtractcolumn(tablex, _val); } }


  public String getname() { return name; }

  public static List getAllname(List tables)
  { List result = new Vector();
    for (int i = 0; i < tables.size(); i++)
    { Table tablex = (Table) tables.get(i);
      if (result.contains(tablex.getname())) { }
      else { result.add(tablex.getname()); } }
    return result; }

  public static List getAllOrderedname(List tables)
  { List result = new Vector();
    for (int i = 0; i < tables.size(); i++)
    { Table tablex = (Table) tables.get(i);
      result.add(tablex.getname()); } 
    return result; }

  public List getcolumn() { return (Vector) ((Vector) column).clone(); }

  public static List getAllcolumn(List tables)
  { List result = new Vector();
    for (int _i = 0; _i < tables.size(); _i++)
    { Table tablex = (Table) tables.get(_i);
      result = Set.union(result,tablex.getcolumn()); }
    return result; }

  public static List getAllOrderedcolumn(List tables)
  { List result = new Vector();
    for (int _i = 0; _i < tables.size(); _i++)
    { Table tablex = (Table) tables.get(_i);
      result = Set.union(result,tablex.getcolumn()); }
    return result; }


}


class Type
  implements SystemTypes
{
  private String name = ""; // internal

  public Type()
  {
    this.name = "";

  }



  public String toString()
  { String _res_ = "(Type) ";
    _res_ = _res_ + name;
    return _res_;
  }

  public void setname(String name_x) { name = name_x;  }


  public static void setAllname(List types,String val)
{ for (int i = 0; i < types.size(); i++)
    { Type typex = (Type) types.get(i);
      Controller.inst().setname(typex,val); } }


  public String getname() { return name; }

  public static List getAllname(List types)
  { List result = new Vector();
    for (int i = 0; i < types.size(); i++)
    { Type typex = (Type) types.get(i);
      if (result.contains(typex.getname())) { }
      else { result.add(typex.getname()); } }
    return result; }

  public static List getAllOrderedname(List types)
  { List result = new Vector();
    for (int i = 0; i < types.size(); i++)
    { Type typex = (Type) types.get(i);
      result.add(typex.getname()); } 
    return result; }


}



public class Controller implements SystemTypes, ControllerInterface
{
  Vector attributes = new Vector();
  Vector columns = new Vector();
  Vector umlclasss = new Vector();
  Map umlclassnameindex = new HashMap(); // String --> UMLClass

  Vector tables = new Vector();
  Map tablenameindex = new HashMap(); // String --> Table

  Vector types = new Vector();
  private static Controller uniqueInstance; 


  private Controller() { } 


  public static Controller inst() 
    { if (uniqueInstance == null) 
    { uniqueInstance = new Controller(); }
    return uniqueInstance; } 


  public static void loadModel(String file)
  {
    try
    { BufferedReader br = null;
      File f = new File(file);
      try 
      { br = new BufferedReader(new FileReader(f)); }
      catch (Exception ex) 
      { System.err.println("No file: " + file); return; }
      Class cont = Class.forName("Controller");
      java.util.Map objectmap = new java.util.HashMap();
      while (true)
      { String line1;
        try { line1 = br.readLine(); }
        catch (Exception e)
        { return; }
        if (line1 == null)
        { return; }
        line1 = line1.trim();

        if (line1.length() == 0) { continue; }
        String left;
        String op;
        String right;
        if (line1.charAt(line1.length() - 1) == '"')
        { int eqind = line1.indexOf("="); 
          if (eqind == -1) { continue; }
          else 
          { left = line1.substring(0,eqind-1).trim();
            op = "="; 
            right = line1.substring(eqind+1,line1.length()).trim();
          }
        }
        else
        { StringTokenizer st1 = new StringTokenizer(line1);
          Vector vals1 = new Vector();
          while (st1.hasMoreTokens())
          { String val1 = st1.nextToken();
            vals1.add(val1);
          }
          if (vals1.size() < 3)
          { continue; }
          left = (String) vals1.get(0);
          op = (String) vals1.get(1);
          right = (String) vals1.get(2);
        }
        if (":".equals(op))
        { int i2 = right.indexOf(".");
          if (i2 == -1)
          { Class cl;
            try { cl = Class.forName("" + right); }
            catch (Exception _x) { System.err.println("No entity: " + right); continue; }
            Object xinst = cl.newInstance();
            objectmap.put(left,xinst);
            Class[] cargs = new Class[] { cl };
            Method addC = cont.getMethod("add" + right,cargs);
            if (addC == null) { continue; }
            Object[] args = new Object[] { xinst };
            addC.invoke(Controller.inst(),args);
          }
          else
          { String obj = right.substring(0,i2);
            String role = right.substring(i2+1,right.length());
            Object objinst = objectmap.get(obj); 
            if (objinst == null) 
            { continue; }
            Object val = objectmap.get(left);
            if (val == null) 
            { continue; }
            Class objC = objinst.getClass();
            Class typeclass = val.getClass(); 
            Object[] args = new Object[] { val }; 
            Class[] settypes = new Class[] { typeclass };
            Method addrole = Controller.findMethod(objC,"add" + role);
            if (addrole != null) 
            { addrole.invoke(objinst, args); }
            else { System.err.println("Error: cannot add to " + role); }
          }
        }
        else if ("=".equals(op))
        { int i1 = left.indexOf(".");
          if (i1 == -1) 
          { continue; }
          String obj = left.substring(0,i1);
          String att = left.substring(i1+1,left.length());
          Object objinst = objectmap.get(obj); 
          if (objinst == null) 
          { continue; }
          Class objC = objinst.getClass();
          Class typeclass; 
          Object val; 
          if (right.charAt(0) == '"' &&
              right.charAt(right.length() - 1) == '"')
          { typeclass = String.class;
            val = right.substring(1,right.length() - 1);
          } 
          else if ("true".equals(right) || "false".equals(right))
          { typeclass = boolean.class;
            if ("true".equals(right))
            { val = new Boolean(true); }
            else
            { val = new Boolean(false); }
          }
          else 
          { val = objectmap.get(right);
            if (val != null)
            { typeclass = val.getClass(); }
            else 
            { int i;
              long l; 
              double d;
              try 
              { i = Integer.parseInt(right);
                typeclass = int.class;
                val = new Integer(i); 
              }
              catch (Exception ee)
              { try 
                { l = Long.parseLong(right);
                  typeclass = long.class;
                  val = new Long(l); 
                }
                catch (Exception eee)
                { try
                  { d = Double.parseDouble(right);
                    typeclass = double.class;
                    val = new Double(d);
                  }
                  catch (Exception ff)
                  { continue; }
                }
              }
            }
          }
          Object[] args = new Object[] { val }; 
          Class[] settypes = new Class[] { typeclass };
          Method setatt = Controller.findMethod(objC,"set" + att);
          if (setatt != null) 
          { setatt.invoke(objinst, args); }
          else { System.err.println("No attribute: " + att); }
        }
      }
    } catch (Exception e) { }
  }

  public static Method findMethod(Class c, String name)
  { Method[] mets = c.getMethods(); 
    for (int i = 0; i < mets.length; i++)
    { Method m = mets[i];
      if (m.getName().equals(name))
      { return m; }
    } 
    return null;
  }


  public void checkCompleteness()
  {   for (int _i = 0; _i < umlclasss.size(); _i++)
  { UMLClass umlclass_x = (UMLClass) umlclasss.get(_i);
    UMLClass umlclass_obj = (UMLClass) umlclassnameindex.get(umlclass_x.getname());
    if (umlclass_obj == umlclass_x) { }
    else if (umlclass_obj == null)
    { umlclassnameindex.put(umlclass_x.getname(),umlclass_x); }
    else
    { System.out.println("Error: multiple objects with id1 = " + umlclass_x.getname()); }
  }
  for (int _i = 0; _i < tables.size(); _i++)
  { Table table_x = (Table) tables.get(_i);
    Table table_obj = (Table) tablenameindex.get(table_x.getname());
    if (table_obj == table_x) { }
    else if (table_obj == null)
    { tablenameindex.put(table_x.getname(),table_x); }
    else
    { System.out.println("Error: multiple objects with id1 = " + table_x.getname()); }
  }
  }


  public void saveModel(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
  for (int _i = 0; _i < attributes.size(); _i++)
  { Attribute attributex_ = (Attribute) attributes.get(_i);
    out.println("attributex_" + _i + " : Attribute");
    out.println("attributex_" + _i + ".name = \"" + attributex_.getname() + "\"");
  }

  for (int _i = 0; _i < columns.size(); _i++)
  { Column columnx_ = (Column) columns.get(_i);
    out.println("columnx_" + _i + " : Column");
    out.println("columnx_" + _i + ".name = \"" + columnx_.getname() + "\"");
    out.println("columnx_" + _i + ".coltype = \"" + columnx_.getcoltype() + "\"");
  }

  for (int _i = 0; _i < umlclasss.size(); _i++)
  { UMLClass umlclassx_ = (UMLClass) umlclasss.get(_i);
    out.println("umlclassx_" + _i + " : UMLClass");
    out.println("umlclassx_" + _i + ".name = \"" + umlclassx_.getname() + "\"");
  }

  for (int _i = 0; _i < tables.size(); _i++)
  { Table tablex_ = (Table) tables.get(_i);
    out.println("tablex_" + _i + " : Table");
    out.println("tablex_" + _i + ".name = \"" + tablex_.getname() + "\"");
  }

  for (int _i = 0; _i < types.size(); _i++)
  { Type typex_ = (Type) types.get(_i);
    out.println("typex_" + _i + " : Type");
    out.println("typex_" + _i + ".name = \"" + typex_.getname() + "\"");
  }

  for (int _i = 0; _i < attributes.size(); _i++)
  { Attribute attributex_ = (Attribute) attributes.get(_i);
    out.println("attributex_" + _i + ".type = typex_" + types.indexOf(((Attribute) attributes.get(_i)).gettype()));
  }
  for (int _i = 0; _i < umlclasss.size(); _i++)
  { UMLClass umlclassx_ = (UMLClass) umlclasss.get(_i);
    List umlclass_attribute_Attribute = umlclassx_.getattribute();
    for (int _j = 0; _j < umlclass_attribute_Attribute.size(); _j++)
    { out.println("attributex_" + attributes.indexOf(umlclass_attribute_Attribute.get(_j)) + " : umlclassx_" + _i + ".attribute");
    }
  }
  for (int _i = 0; _i < tables.size(); _i++)
  { Table tablex_ = (Table) tables.get(_i);
    List table_column_Column = tablex_.getcolumn();
    for (int _j = 0; _j < table_column_Column.size(); _j++)
    { out.println("columnx_" + columns.indexOf(table_column_Column.get(_j)) + " : tablex_" + _i + ".column");
    }
  }
    out.close(); 
  }


  public void saveXSI(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
    out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    out.println("<My:model xmi:version=\"2.0\" xmlns:xmi=\"http://www.omg.org/XMI\">");
    for (int _i = 0; _i < attributes.size(); _i++)
    { Attribute attributex_ = (Attribute) attributes.get(_i);
       out.print("<attributes xsi:type=\"My:Attribute\"");
    out.print(" name=\"" + attributex_.getname() + "\" ");
    out.print(" type=\"");
    out.print("//@types." + types.indexOf(((Attribute) attributes.get(_i)).gettype()));
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < columns.size(); _i++)
    { Column columnx_ = (Column) columns.get(_i);
       out.print("<columns xsi:type=\"My:Column\"");
    out.print(" name=\"" + columnx_.getname() + "\" ");
    out.print(" coltype=\"" + columnx_.getcoltype() + "\" ");
    out.println(" />");
  }

    for (int _i = 0; _i < umlclasss.size(); _i++)
    { UMLClass umlclassx_ = (UMLClass) umlclasss.get(_i);
       out.print("<umlclasss xsi:type=\"My:UMLClass\"");
    out.print(" name=\"" + umlclassx_.getname() + "\" ");
    out.print(" attribute = \"");
    List umlclass_attribute = umlclassx_.getattribute();
    for (int _j = 0; _j < umlclass_attribute.size(); _j++)
    { out.print(" //@attributes." + attributes.indexOf(umlclass_attribute.get(_j)));
    }
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < tables.size(); _i++)
    { Table tablex_ = (Table) tables.get(_i);
       out.print("<tables xsi:type=\"My:Table\"");
    out.print(" name=\"" + tablex_.getname() + "\" ");
    out.print(" column = \"");
    List table_column = tablex_.getcolumn();
    for (int _j = 0; _j < table_column.size(); _j++)
    { out.print(" //@columns." + columns.indexOf(table_column.get(_j)));
    }
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < types.size(); _i++)
    { Type typex_ = (Type) types.get(_i);
       out.print("<types xsi:type=\"My:Type\"");
    out.print(" name=\"" + typex_.getname() + "\" ");
    out.println(" />");
  }

    out.println("</My:model>");
    out.close(); 
  }



  public void addAttribute(Attribute oo) { attributes.add(oo); }

  public void addColumn(Column oo) { columns.add(oo); }

  public void addUMLClass(UMLClass oo) { umlclasss.add(oo); }

  public UMLClass getUMLClassByPK(String namex)
  {  return (UMLClass) umlclassnameindex.get(namex); }

  public List getUMLClassByPK(List namex)
  { Vector res = new Vector(); 
    for (int _i = 0; _i < namex.size(); _i++)
    { UMLClass umlclassx = getUMLClassByPK((String) namex.get(_i));
      if (umlclassx != null) { res.add(umlclassx); }
    }
    return res; 
  }

  public void addTable(Table oo) { tables.add(oo); }

  public Table getTableByPK(String namex)
  {  return (Table) tablenameindex.get(namex); }

  public List getTableByPK(List namex)
  { Vector res = new Vector(); 
    for (int _i = 0; _i < namex.size(); _i++)
    { Table tablex = getTableByPK((String) namex.get(_i));
      if (tablex != null) { res.add(tablex); }
    }
    return res; 
  }

  public void addType(Type oo) { types.add(oo); }



  public void createAllAttribute(List attributex)
  { for (int i = 0; i < attributex.size(); i++)
    { Attribute attributex_x = (Attribute) attributex.get(i);
      if (attributex_x == null) { attributex_x = new Attribute(); }
      attributex.set(i,attributex_x);
      addAttribute(attributex_x);
    }
  }


  public Attribute createAttribute(Type typex)
  { 
    Attribute attributex = new Attribute(typex);
    addAttribute(attributex);
    setname(attributex,"");
    settype(attributex,typex);

    return attributex;
  }

  public void createAllColumn(List columnx)
  { for (int i = 0; i < columnx.size(); i++)
    { Column columnx_x = (Column) columnx.get(i);
      if (columnx_x == null) { columnx_x = new Column(); }
      columnx.set(i,columnx_x);
      addColumn(columnx_x);
    }
  }


  public Column createColumn()
  { 
    Column columnx = new Column();
    addColumn(columnx);
    setname(columnx,"");
    setcoltype(columnx,"");

    return columnx;
  }

  public void createAllUMLClass(List umlclassx)
  { for (int i = 0; i < umlclassx.size(); i++)
    { UMLClass umlclassx_x = (UMLClass) umlclassx.get(i);
      if (umlclassx_x == null) { umlclassx_x = new UMLClass(); }
      umlclassx.set(i,umlclassx_x);
      addUMLClass(umlclassx_x);
    }
  }


  public UMLClass createUMLClass(String namex)
  { 
    if (umlclassnameindex.get(namex) != null) { return null; }
    UMLClass umlclassx = new UMLClass();
    addUMLClass(umlclassx);
    setname(umlclassx,namex);
    setattribute(umlclassx,new Vector());
    umlclassnameindex.put(namex,umlclassx);

    return umlclassx;
  }

  public void createAllTable(List tablex)
  { for (int i = 0; i < tablex.size(); i++)
    { Table tablex_x = (Table) tablex.get(i);
      if (tablex_x == null) { tablex_x = new Table(); }
      tablex.set(i,tablex_x);
      addTable(tablex_x);
    }
  }


  public Table createTable(String namex)
  { 
    if (tablenameindex.get(namex) != null) { return null; }
    Table tablex = new Table();
    addTable(tablex);
    setname(tablex,namex);
    setcolumn(tablex,new Vector());
    tablenameindex.put(namex,tablex);

    return tablex;
  }

  public void createAllType(List typex)
  { for (int i = 0; i < typex.size(); i++)
    { Type typex_x = (Type) typex.get(i);
      if (typex_x == null) { typex_x = new Type(); }
      typex.set(i,typex_x);
      addType(typex_x);
    }
  }


  public Type createType()
  { 
    Type typex = new Type();
    addType(typex);
    setname(typex,"");

    return typex;
  }


public void setname(Attribute attributex, String name_x) 
  { attributex.setname(name_x);
    }


  public void settype(Attribute attributex, Type typexx) 
  {   if (attributex.gettype() == typexx) { return; }
    attributex.settype(typexx);
      }


public void setname(Column columnx, String name_x) 
  { columnx.setname(name_x);
    }


public void setcoltype(Column columnx, String coltype_x) 
  { columnx.setcoltype(coltype_x);
    }


public void setname(UMLClass umlclassx, String name_x) 
  { if (umlclassnameindex.get(name_x) != null) { return; }
  umlclassnameindex.remove(umlclassx.getname());
  umlclassx.setname(name_x);
  umlclassnameindex.put(name_x,umlclassx);
    }


  public void setattribute(UMLClass umlclassx, List attributexx) 
  {   List _oldattributexx = umlclassx.getattribute();
  for (int _i = 0; _i < attributexx.size(); _i++)
  { Attribute _xx = (Attribute) attributexx.get(_i);
    if (_oldattributexx.contains(_xx)) { }
    else { UMLClass.removeAllattribute(umlclasss, _xx); }
  }
    umlclassx.setattribute(attributexx);
      }


  public void addattribute(UMLClass umlclassx, Attribute attributexx) 
  { if (umlclassx.getattribute().contains(attributexx)) { return; }
    UMLClass.removeAllattribute(umlclasss,attributexx);
    umlclassx.addattribute(attributexx);
    }


  public void removeattribute(UMLClass umlclassx, Attribute attributexx) 
  { umlclassx.removeattribute(attributexx);
    }


 public void unionattribute(UMLClass umlclassx,List attributex)
  { for (int _i = 0; _i < attributex.size(); _i++)
    { Attribute attributexattribute = (Attribute) attributex.get(_i);
      addattribute(umlclassx,attributexattribute);
     } } 


 public void subtractattribute(UMLClass umlclassx,List attributex)
  { for (int _i = 0; _i < attributex.size(); _i++)
    { Attribute attributexattribute = (Attribute) attributex.get(_i);
      removeattribute(umlclassx,attributexattribute);
     } } 


public void setname(Table tablex, String name_x) 
  { if (tablenameindex.get(name_x) != null) { return; }
  tablenameindex.remove(tablex.getname());
  tablex.setname(name_x);
  tablenameindex.put(name_x,tablex);
    }


  public void setcolumn(Table tablex, List columnxx) 
  {   List _oldcolumnxx = tablex.getcolumn();
  for (int _i = 0; _i < columnxx.size(); _i++)
  { Column _xx = (Column) columnxx.get(_i);
    if (_oldcolumnxx.contains(_xx)) { }
    else { Table.removeAllcolumn(tables, _xx); }
  }
    tablex.setcolumn(columnxx);
      }


  public void addcolumn(Table tablex, Column columnxx) 
  { if (tablex.getcolumn().contains(columnxx)) { return; }
    Table.removeAllcolumn(tables,columnxx);
    tablex.addcolumn(columnxx);
    }


  public void removecolumn(Table tablex, Column columnxx) 
  { tablex.removecolumn(columnxx);
    }


 public void unioncolumn(Table tablex,List columnx)
  { for (int _i = 0; _i < columnx.size(); _i++)
    { Column columnxcolumn = (Column) columnx.get(_i);
      addcolumn(tablex,columnxcolumn);
     } } 


 public void subtractcolumn(Table tablex,List columnx)
  { for (int _i = 0; _i < columnx.size(); _i++)
    { Column columnxcolumn = (Column) columnx.get(_i);
      removecolumn(tablex,columnxcolumn);
     } } 


public void setname(Type typex, String name_x) 
  { typex.setname(name_x);
    }





  public void killAllAttribute(List attributexx)
  { for (int _i = 0; _i < attributexx.size(); _i++)
    { killAttribute((Attribute) attributexx.get(_i)); }
  }

  public void killAttribute(Attribute attributexx)
  { attributes.remove(attributexx);
    Vector _1qrangeattributeUMLClass = new Vector();
    _1qrangeattributeUMLClass.addAll(umlclasss);
    for (int _i = 0; _i < _1qrangeattributeUMLClass.size(); _i++)
    { UMLClass umlclassx = (UMLClass) _1qrangeattributeUMLClass.get(_i);
      if (umlclassx.getattribute().contains(attributexx))
      { removeattribute(umlclassx,attributexx); }
    }
  }



  public void killAllColumn(List columnxx)
  { for (int _i = 0; _i < columnxx.size(); _i++)
    { killColumn((Column) columnxx.get(_i)); }
  }

  public void killColumn(Column columnxx)
  { columns.remove(columnxx);
    Vector _1qrangecolumnTable = new Vector();
    _1qrangecolumnTable.addAll(tables);
    for (int _i = 0; _i < _1qrangecolumnTable.size(); _i++)
    { Table tablex = (Table) _1qrangecolumnTable.get(_i);
      if (tablex.getcolumn().contains(columnxx))
      { removecolumn(tablex,columnxx); }
    }
  }



  public void killAllUMLClass(List umlclassxx)
  { for (int _i = 0; _i < umlclassxx.size(); _i++)
    { killUMLClass((UMLClass) umlclassxx.get(_i)); }
  }

  public void killUMLClass(UMLClass umlclassxx)
  { umlclasss.remove(umlclassxx);
    umlclassnameindex.remove(umlclassxx.getname());
  }



  public void killAllTable(List tablexx)
  { for (int _i = 0; _i < tablexx.size(); _i++)
    { killTable((Table) tablexx.get(_i)); }
  }

  public void killTable(Table tablexx)
  { tables.remove(tablexx);
    tablenameindex.remove(tablexx.getname());
  }



  public void killAllType(List typexx)
  { for (int _i = 0; _i < typexx.size(); _i++)
    { killType((Type) typexx.get(_i)); }
  }

  public void killType(Type typexx)
  { types.remove(typexx);
    Vector _1removedtypeAttribute = new Vector();
    Vector _1qrangetypeAttribute = new Vector();
    _1qrangetypeAttribute.addAll(attributes);
    for (int _i = 0; _i < _1qrangetypeAttribute.size(); _i++)
    { Attribute attributex = (Attribute) _1qrangetypeAttribute.get(_i);
      if (attributex != null && typexx.equals(attributex.gettype()))
      { _1removedtypeAttribute.add(attributex);
        attributex.settype(null);
      }
    }
    for (int _i = 0; _i < _1removedtypeAttribute.size(); _i++)
    { killAttribute((Attribute) _1removedtypeAttribute.get(_i)); }
  }




  
    public void tau() 
  { 
   Date d1 = new Date(); 
   long t1 = d1.getTime(); 

    List _range1 = Controller.inst().umlclasss;
  for (int _i0 = 0; _i0 < _range1.size(); _i0++)
  { UMLClass c = (UMLClass) _range1.get(_i0);
      String n;
  n = c.getname();
  Table t; 
       if (Controller.inst().getTableByPK(n) != null)
    { t = Controller.inst().getTableByPK(n);
   }
    else
    {  t = new Table();
    Controller.inst().addTable(t);
    Controller.inst().setname(t,n); }

    Controller.inst().attribute2column$op(c,t);

  }
   Date d2 = new Date(); 
   long t2 = d2.getTime(); 
   System.out.println("Time = " + (t2-t1)); 


  }

    public void attribute2column$op(UMLClass c,Table t)
  {    List _range3 = c.getattribute();
  for (int _i2 = 0; _i2 < _range3.size(); _i2++)
  { Attribute a = (Attribute) _range3.get(_i2);
      String n;
  n = a.getname();
    Type typ = a.gettype();
    String tn;
  tn = typ.getname();
     {}
    Column col = new Column();
    Controller.inst().addColumn(col);
    Controller.inst().addcolumn(t,col);
    Controller.inst().setname(col,n);
    Controller.inst().setcoltype(col,tn);

  }
  }



 
}



